=== modified file 'drizzled/info_schema.h'
--- drizzled/info_schema.h	2009-06-29 16:05:47 +0000
+++ drizzled/info_schema.h	2009-07-01 03:36:14 +0000
@@ -21,6 +21,8 @@
 #ifndef DRIZZLED_INFO_SCHEMA_H
 #define DRIZZLED_INFO_SCHEMA_H
 
+#include <string>
+
 /**
  * @file
  *   info_schema.h
@@ -32,8 +34,7 @@
 
 
 /**
- * @class 
- *   ColumnInfo
+ * @class ColumnInfo
  * @brief
  *   Represents a field (column) in an I_S table.
  */
@@ -177,8 +178,7 @@
 };
 
 /**
- * @class 
- *   InfoSchemaMethods
+ * @class InfoSchemaMethods
  * @brief
  *   The methods that an I_S table can support
  */
@@ -199,12 +199,6 @@
                         InfoSchemaTable *schema_table) const;
 };
 
-class ColumnsISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
-};
-
 class StatusISMethods : public InfoSchemaMethods
 {
 public:
@@ -221,48 +215,8 @@
                         COND *cond);
 };
 
-class OpenTablesISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int fillTable(Session *session, 
-                        TableList *tables,
-                        COND *cond);
-};
-
-class SchemataISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int fillTable(Session *session, 
-                        TableList *tables,
-                        COND *cond);
-  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
-};
-
-class StatsISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int processTable(Session *session, TableList *tables,
-                           Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
-};
-
-class TablesISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int processTable(Session *session, TableList *tables,
-                           Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
-};
-
-class TabNamesISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
-};
-
 /**
- * @class 
- *   InfoSchemaTable
+ * @class InfoSchemaTable
  * @brief 
  *   Represents an I_S table.
  */

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-06-30 18:31:32 +0000
+++ drizzled/show.cc	2009-07-01 06:40:41 +0000
@@ -1355,13 +1355,6 @@
 /* This is only used internally, but we need it here as a forward reference */
 extern InfoSchemaTable schema_tables[];
 
-typedef struct st_lookup_field_values
-{
-  LEX_STRING db_value, table_value;
-  bool wild_db_value, wild_table_value;
-} LOOKUP_FIELD_VALUES;
-
-
 /*
   Store record to I_S table, convert HEAP table
   to MyISAM if necessary
@@ -2381,259 +2374,6 @@
 }
 
 
-bool store_schema_shemata(Session* session, Table *table, LEX_STRING *db_name,
-                          const CHARSET_INFO * const cs)
-{
-  table->restoreRecordAsDefault();
-  table->field[1]->store(db_name->str, db_name->length, system_charset_info);
-  table->field[2]->store(cs->csname, strlen(cs->csname), system_charset_info);
-  table->field[3]->store(cs->name, strlen(cs->name), system_charset_info);
-  return schema_table_store_record(session, table);
-}
-
-
-int SchemataISMethods::fillTable(Session *session, TableList *tables, COND *cond)
-{
-  /*
-    TODO: fill_schema_shemata() is called when new client is connected.
-    Returning error status in this case leads to client hangup.
-  */
-
-  LOOKUP_FIELD_VALUES lookup_field_vals;
-  List<LEX_STRING> db_names;
-  LEX_STRING *db_name;
-  bool with_i_schema;
-  Table *table= tables->table;
-
-  if (get_lookup_field_values(session, cond, tables, &lookup_field_vals))
-    return(0);
-  if (make_db_list(session, &db_names, &lookup_field_vals,
-                   &with_i_schema))
-    return(1);
-
-  /*
-    If we have lookup db value we should check that the database exists
-  */
-  if(lookup_field_vals.db_value.str && !lookup_field_vals.wild_db_value &&
-     !with_i_schema)
-  {
-    char path[FN_REFLEN+16];
-    uint32_t path_len;
-    struct stat stat_info;
-    if (!lookup_field_vals.db_value.str[0])
-      return(0);
-    path_len= build_table_filename(path, sizeof(path),
-                                   lookup_field_vals.db_value.str, "", false);
-    path[path_len-1]= 0;
-    if (stat(path,&stat_info))
-      return(0);
-  }
-
-  List_iterator_fast<LEX_STRING> it(db_names);
-  while ((db_name=it++))
-  {
-    if (with_i_schema)       // information schema name is always first in list
-    {
-      if (store_schema_shemata(session, table, db_name,
-                               system_charset_info))
-        return(1);
-      with_i_schema= 0;
-      continue;
-    }
-    {
-      HA_CREATE_INFO create;
-      load_db_opt_by_name(db_name->str, &create);
-
-      if (store_schema_shemata(session, table, db_name,
-                               create.default_table_charset))
-        return(1);
-    }
-  }
-  return(0);
-}
-
-
-int TablesISMethods::processTable(Session *session, TableList *tables,
-				    Table *table, bool res,
-				    LEX_STRING *db_name,
-				    LEX_STRING *table_name) const
-{
-  const char *tmp_buff;
-  DRIZZLE_TIME time;
-  const CHARSET_INFO * const cs= system_charset_info;
-
-  table->restoreRecordAsDefault();
-  table->field[1]->store(db_name->str, db_name->length, cs);
-  table->field[2]->store(table_name->str, table_name->length, cs);
-  if (res)
-  {
-    /*
-      there was errors during opening tables
-    */
-    const char *error= session->is_error() ? session->main_da.message() : "";
-    if (tables->schema_table)
-      table->field[3]->store(STRING_WITH_LEN("SYSTEM VIEW"), cs);
-    else
-      table->field[3]->store(STRING_WITH_LEN("BASE Table"), cs);
-    table->field[20]->store(error, strlen(error), cs);
-    session->clear_error();
-  }
-  else
-  {
-    char option_buff[400],*ptr;
-    Table *show_table= tables->table;
-    TableShare *share= show_table->s;
-    handler *file= show_table->file;
-    StorageEngine *tmp_db_type= share->db_type();
-    if (share->tmp_table == SYSTEM_TMP_TABLE)
-      table->field[3]->store(STRING_WITH_LEN("SYSTEM VIEW"), cs);
-    else if (share->tmp_table)
-      table->field[3]->store(STRING_WITH_LEN("LOCAL TEMPORARY"), cs);
-    else
-      table->field[3]->store(STRING_WITH_LEN("BASE Table"), cs);
-
-    for (int i= 4; i < 20; i++)
-    {
-      if (i == 7 || (i > 12 && i < 17) || i == 18)
-        continue;
-      table->field[i]->set_notnull();
-    }
-    string engine_name= ha_resolve_storage_engine_name(tmp_db_type);
-    table->field[4]->store(engine_name.c_str(), engine_name.size(), cs);
-    table->field[5]->store((int64_t) 0, true);
-
-    ptr=option_buff;
-    if (share->min_rows)
-    {
-      ptr= strcpy(ptr," min_rows=")+10;
-      ptr= int64_t10_to_str(share->min_rows,ptr,10);
-    }
-    if (share->max_rows)
-    {
-      ptr= strcpy(ptr," max_rows=")+10;
-      ptr= int64_t10_to_str(share->max_rows,ptr,10);
-    }
-    if (share->avg_row_length)
-    {
-      ptr= strcpy(ptr," avg_row_length=")+16;
-      ptr= int64_t10_to_str(share->avg_row_length,ptr,10);
-    }
-    if (share->db_create_options & HA_OPTION_PACK_KEYS)
-      ptr= strcpy(ptr," pack_keys=1")+12;
-    if (share->db_create_options & HA_OPTION_NO_PACK_KEYS)
-      ptr= strcpy(ptr," pack_keys=0")+12;
-    /* We use CHECKSUM, instead of TABLE_CHECKSUM, for backward compability */
-    if (share->db_create_options & HA_OPTION_CHECKSUM)
-      ptr= strcpy(ptr," checksum=1")+11;
-    if (share->page_checksum != HA_CHOICE_UNDEF)
-      ptr+= sprintf(ptr, " page_checksum=%s",
-                    ha_choice_values[(uint32_t) share->page_checksum]);
-    if (share->db_create_options & HA_OPTION_DELAY_KEY_WRITE)
-      ptr= strcpy(ptr," delay_key_write=1")+18;
-    if (share->row_type != ROW_TYPE_DEFAULT)
-      ptr+= sprintf(ptr, " row_format=%s", ha_row_type[(uint32_t)share->row_type]);
-    if (share->block_size)
-    {
-      ptr= strcpy(ptr, " block_size=")+12;
-      ptr= int64_t10_to_str(share->block_size, ptr, 10);
-    }
-
-    table->field[19]->store(option_buff+1,
-                            (ptr == option_buff ? 0 :
-                             (uint32_t) (ptr-option_buff)-1), cs);
-
-    tmp_buff= (share->table_charset ?
-               share->table_charset->name : "default");
-    table->field[17]->store(tmp_buff, strlen(tmp_buff), cs);
-
-    if (share->comment.str)
-      table->field[20]->store(share->comment.str, share->comment.length, cs);
-
-    if(file)
-    {
-      file->info(HA_STATUS_VARIABLE | HA_STATUS_TIME | HA_STATUS_AUTO |
-                 HA_STATUS_NO_LOCK);
-      enum row_type row_type = file->get_row_type();
-      switch (row_type) {
-      case ROW_TYPE_NOT_USED:
-      case ROW_TYPE_DEFAULT:
-        tmp_buff= ((share->db_options_in_use &
-                    HA_OPTION_COMPRESS_RECORD) ? "Compressed" :
-                   (share->db_options_in_use & HA_OPTION_PACK_RECORD) ?
-                   "Dynamic" : "Fixed");
-        break;
-      case ROW_TYPE_FIXED:
-        tmp_buff= "Fixed";
-        break;
-      case ROW_TYPE_DYNAMIC:
-        tmp_buff= "Dynamic";
-        break;
-      case ROW_TYPE_COMPRESSED:
-        tmp_buff= "Compressed";
-        break;
-      case ROW_TYPE_REDUNDANT:
-        tmp_buff= "Redundant";
-        break;
-      case ROW_TYPE_COMPACT:
-        tmp_buff= "Compact";
-        break;
-      case ROW_TYPE_PAGE:
-        tmp_buff= "Paged";
-        break;
-      }
-      table->field[6]->store(tmp_buff, strlen(tmp_buff), cs);
-      if (!tables->schema_table)
-      {
-        table->field[7]->store((int64_t) file->stats.records, true);
-        table->field[7]->set_notnull();
-      }
-      table->field[8]->store((int64_t) file->stats.mean_rec_length, true);
-      table->field[9]->store((int64_t) file->stats.data_file_length, true);
-      if (file->stats.max_data_file_length)
-      {
-        table->field[10]->store((int64_t) file->stats.max_data_file_length,
-                                true);
-      }
-      table->field[11]->store((int64_t) file->stats.index_file_length, true);
-      table->field[12]->store((int64_t) file->stats.delete_length, true);
-      if (show_table->found_next_number_field)
-      {
-        table->field[13]->store((int64_t) file->stats.auto_increment_value,
-                                true);
-        table->field[13]->set_notnull();
-      }
-      if (file->stats.create_time)
-      {
-        session->variables.time_zone->gmt_sec_to_TIME(&time,
-                                                  (time_t) file->stats.create_time);
-        table->field[14]->store_time(&time, DRIZZLE_TIMESTAMP_DATETIME);
-        table->field[14]->set_notnull();
-      }
-      if (file->stats.update_time)
-      {
-        session->variables.time_zone->gmt_sec_to_TIME(&time,
-                                                  (time_t) file->stats.update_time);
-        table->field[15]->store_time(&time, DRIZZLE_TIMESTAMP_DATETIME);
-        table->field[15]->set_notnull();
-      }
-      if (file->stats.check_time)
-      {
-        session->variables.time_zone->gmt_sec_to_TIME(&time,
-                                                  (time_t) file->stats.check_time);
-        table->field[16]->store_time(&time, DRIZZLE_TIMESTAMP_DATETIME);
-        table->field[16]->set_notnull();
-      }
-      if (file->ha_table_flags() & (ulong) HA_HAS_CHECKSUM)
-      {
-        table->field[18]->store((int64_t) file->checksum(), true);
-        table->field[18]->set_notnull();
-      }
-    }
-  }
-  return(schema_table_store_record(session, table));
-}
-
-
 /**
   @brief    Store field characteristics into appropriate I_S table columns
 
@@ -2863,127 +2603,6 @@
 }
 
 
-int StatsISMethods::processTable(Session *session, TableList *tables,
-				  Table *table, bool res,
-				  LEX_STRING *db_name,
-				  LEX_STRING *table_name) const
-{
-  const CHARSET_INFO * const cs= system_charset_info;
-  if (res)
-  {
-    if (session->lex->sql_command != SQLCOM_SHOW_KEYS)
-    {
-      /*
-        I.e. we are in SELECT FROM INFORMATION_SCHEMA.STATISTICS
-        rather than in SHOW KEYS
-      */
-      if (session->is_error())
-        push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                     session->main_da.sql_errno(), session->main_da.message());
-      session->clear_error();
-      res= 0;
-    }
-    return(res);
-  }
-  else
-  {
-    Table *show_table= tables->table;
-    KEY *key_info=show_table->s->key_info;
-    if (show_table->file)
-      show_table->file->info(HA_STATUS_VARIABLE |
-                             HA_STATUS_NO_LOCK |
-                             HA_STATUS_TIME);
-    for (uint32_t i=0 ; i < show_table->s->keys ; i++,key_info++)
-    {
-      KEY_PART_INFO *key_part= key_info->key_part;
-      const char *str;
-      for (uint32_t j=0 ; j < key_info->key_parts ; j++,key_part++)
-      {
-        table->restoreRecordAsDefault();
-        table->field[1]->store(db_name->str, db_name->length, cs);
-        table->field[2]->store(table_name->str, table_name->length, cs);
-        table->field[3]->store((int64_t) ((key_info->flags &
-                                            HA_NOSAME) ? 0 : 1), true);
-        table->field[4]->store(db_name->str, db_name->length, cs);
-        table->field[5]->store(key_info->name, strlen(key_info->name), cs);
-        table->field[6]->store((int64_t) (j+1), true);
-        str=(key_part->field ? key_part->field->field_name :
-             "?unknown field?");
-        table->field[7]->store(str, strlen(str), cs);
-        if (show_table->file)
-        {
-          if (show_table->file->index_flags(i, j, 0) & HA_READ_ORDER)
-          {
-            table->field[8]->store(((key_part->key_part_flag &
-                                     HA_REVERSE_SORT) ?
-                                    "D" : "A"), 1, cs);
-            table->field[8]->set_notnull();
-          }
-          KEY *key=show_table->key_info+i;
-          if (key->rec_per_key[j])
-          {
-            ha_rows records=(show_table->file->stats.records /
-                             key->rec_per_key[j]);
-            table->field[9]->store((int64_t) records, true);
-            table->field[9]->set_notnull();
-          }
-          str= show_table->file->index_type(i);
-          table->field[13]->store(str, strlen(str), cs);
-        }
-        if ((key_part->field &&
-             key_part->length !=
-             show_table->s->field[key_part->fieldnr-1]->key_length()))
-        {
-          table->field[10]->store((int64_t) key_part->length /
-                                  key_part->field->charset()->mbmaxlen, true);
-          table->field[10]->set_notnull();
-        }
-        uint32_t flags= key_part->field ? key_part->field->flags : 0;
-        const char *pos=(char*) ((flags & NOT_NULL_FLAG) ? "" : "YES");
-        table->field[12]->store(pos, strlen(pos), cs);
-        if (!show_table->s->keys_in_use.test(i))
-          table->field[14]->store(STRING_WITH_LEN("disabled"), cs);
-        else
-          table->field[14]->store("", 0, cs);
-        table->field[14]->set_notnull();
-        assert(test(key_info->flags & HA_USES_COMMENT) ==
-                   (key_info->comment.length > 0));
-        if (key_info->flags & HA_USES_COMMENT)
-          table->field[15]->store(key_info->comment.str,
-                                  key_info->comment.length, cs);
-        if (schema_table_store_record(session, table))
-          return(1);
-      }
-    }
-  }
-  return(res);
-}
-
-
-int OpenTablesISMethods::fillTable(Session *session, TableList *tables, COND *)
-{
-  const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
-  Table *table= tables->table;
-  const CHARSET_INFO * const cs= system_charset_info;
-  OPEN_TableList *open_list;
-  if (!(open_list=list_open_tables(session->lex->select_lex.db, wild))
-            && session->is_fatal_error)
-    return(1);
-
-  for (; open_list ; open_list=open_list->next)
-  {
-    table->restoreRecordAsDefault();
-    table->field[0]->store(open_list->db, strlen(open_list->db), cs);
-    table->field[1]->store(open_list->table, strlen(open_list->table), cs);
-    table->field[2]->store((int64_t) open_list->in_use, true);
-    table->field[3]->store((int64_t) open_list->locked, true);
-    if (schema_table_store_record(session, table))
-      return(1);
-  }
-  return(0);
-}
-
-
 int VariablesISMethods::fillTable(Session *session, TableList *tables, COND *)
 {
   int res= 0;
@@ -3241,107 +2860,6 @@
 }
 
 
-int SchemataISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
-  const
-{
-  char tmp[128];
-  LEX *lex= session->lex;
-  Select_Lex *sel= lex->current_select;
-  Name_resolution_context *context= &sel->context;
-  const InfoSchemaTable::Columns columns= schema_table->getColumns();
-
-  if (!sel->item_list.elements)
-  {
-    const ColumnInfo *column= columns[1];
-    String buffer(tmp,sizeof(tmp), system_charset_info);
-    Item_field *field= new Item_field(context,
-                                      NULL, NULL, column->getName().c_str());
-    if (!field || session->add_item_to_list(field))
-      return 1;
-    buffer.length(0);
-    buffer.append(column->getOldName().c_str());
-    if (lex->wild && lex->wild->ptr())
-    {
-      buffer.append(STRING_WITH_LEN(" ("));
-      buffer.append(lex->wild->ptr());
-      buffer.append(')');
-    }
-    field->set_name(buffer.ptr(), buffer.length(), system_charset_info);
-  }
-  return 0;
-}
-
-
-int TabNamesISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
-  const
-{
-  char tmp[128];
-  String buffer(tmp,sizeof(tmp), session->charset());
-  LEX *lex= session->lex;
-  Name_resolution_context *context= &lex->select_lex.context;
-  const InfoSchemaTable::Columns columns= schema_table->getColumns();
-
-  const ColumnInfo *column= columns[2];
-  buffer.length(0);
-  buffer.append(column->getOldName().c_str());
-  buffer.append(lex->select_lex.db);
-  if (lex->wild && lex->wild->ptr())
-  {
-    buffer.append(STRING_WITH_LEN(" ("));
-    buffer.append(lex->wild->ptr());
-    buffer.append(')');
-  }
-  Item_field *field= new Item_field(context,
-                                    NULL, NULL, column->getName().c_str());
-  if (session->add_item_to_list(field))
-    return 1;
-  field->set_name(buffer.ptr(), buffer.length(), system_charset_info);
-  if (session->lex->verbose)
-  {
-    field->set_name(buffer.ptr(), buffer.length(), system_charset_info);
-    column= columns[3];
-    field= new Item_field(context, NULL, NULL, column->getName().c_str());
-    if (session->add_item_to_list(field))
-      return 1;
-    field->set_name(column->getOldName().c_str(), 
-                    column->getOldName().length(),
-                    system_charset_info);
-  }
-  return 0;
-}
-
-
-int ColumnsISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
-  const
-{
-  int fields_arr[]= {3, 14, 13, 6, 15, 5, 16, 17, 18, -1};
-  int *field_num= fields_arr;
-  const InfoSchemaTable::Columns columns= schema_table->getColumns();
-  const ColumnInfo *column;
-  Name_resolution_context *context= &session->lex->select_lex.context;
-
-  for (; *field_num >= 0; field_num++)
-  {
-    column= columns[*field_num];
-    if (!session->lex->verbose && (*field_num == 13 ||
-                               *field_num == 17 ||
-                               *field_num == 18))
-      continue;
-    Item_field *field= new Item_field(context,
-                                      NULL, NULL, column->getName().c_str());
-    if (field)
-    {
-      field->set_name(column->getOldName().c_str(),
-                      column->getOldName().length(),
-                      system_charset_info);
-      if (session->add_item_to_list(field))
-        return 1;
-    }
-  }
-  return 0;
-}
-
-
 /*
   Create information_schema table
 
@@ -3507,178 +3025,6 @@
   return(result);
 }
 
-ColumnInfo schema_fields_info[]=
-{
-  ColumnInfo("CATALOG_NAME",
-            FN_REFLEN,
-            DRIZZLE_TYPE_VARCHAR,
-            0, 1, "", SKIP_OPEN_TABLE),
-  ColumnInfo("SCHEMA_NAME",
-            NAME_CHAR_LEN,
-            DRIZZLE_TYPE_VARCHAR,
-            0, 0, "Database", SKIP_OPEN_TABLE),
-  ColumnInfo("DEFAULT_CHARACTER_SET_NAME", 
-            64, DRIZZLE_TYPE_VARCHAR, 0, 0, "",
-            SKIP_OPEN_TABLE),
-  ColumnInfo("DEFAULT_COLLATION_NAME",
-            64, DRIZZLE_TYPE_VARCHAR, 0, 0, "",
-            SKIP_OPEN_TABLE),
-  ColumnInfo("SQL_PATH",
-            FN_REFLEN,
-            DRIZZLE_TYPE_VARCHAR,
-            0, 1, "", SKIP_OPEN_TABLE),
-  ColumnInfo()
-};
-
-
-ColumnInfo tables_fields_info[]=
-{
-  ColumnInfo("TABLE_CATALOG",  FN_REFLEN, DRIZZLE_TYPE_VARCHAR,
-            0, 1, "", SKIP_OPEN_TABLE),
-  ColumnInfo("TABLE_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR,
-            0, 0, "", SKIP_OPEN_TABLE), 
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR,
-            0, 0, "Name", SKIP_OPEN_TABLE),
-  ColumnInfo("TABLE_TYPE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR,
-            0, 0, "", OPEN_FRM_ONLY),
-  ColumnInfo("ENGINE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR,
-            0, 1, "Engine", OPEN_FRM_ONLY),
-  ColumnInfo("VERSION", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Version", OPEN_FRM_ONLY),
-  ColumnInfo("ROW_FORMAT", 10, DRIZZLE_TYPE_VARCHAR, 0, 1, "Row_format", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_ROWS", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Rows", OPEN_FULL_TABLE),
-  ColumnInfo("AVG_ROW_LENGTH", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Avg_row_length", OPEN_FULL_TABLE),
-  ColumnInfo("DATA_LENGTH", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Data_length", OPEN_FULL_TABLE),
-  ColumnInfo("MAX_DATA_LENGTH", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Max_data_length", OPEN_FULL_TABLE),
-  ColumnInfo("INDEX_LENGTH", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Index_length", OPEN_FULL_TABLE),
-  ColumnInfo("DATA_FREE", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Data_free", OPEN_FULL_TABLE),
-  ColumnInfo("AUTO_INCREMENT", MY_INT64_NUM_DECIMAL_DIGITS , DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Auto_increment", OPEN_FULL_TABLE),
-  ColumnInfo("CREATE_TIME", 0, DRIZZLE_TYPE_DATETIME, 0, 1, "Create_time", OPEN_FULL_TABLE),
-  ColumnInfo("UPDATE_TIME", 0, DRIZZLE_TYPE_DATETIME, 0, 1, "Update_time", OPEN_FULL_TABLE),
-  ColumnInfo("CHECK_TIME", 0, DRIZZLE_TYPE_DATETIME, 0, 1, "Check_time", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_COLLATION", 64, DRIZZLE_TYPE_VARCHAR, 0, 1, "Collation", OPEN_FRM_ONLY),
-  ColumnInfo("CHECKSUM", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "Checksum", OPEN_FULL_TABLE),
-  ColumnInfo("CREATE_OPTIONS", 255, DRIZZLE_TYPE_VARCHAR, 0, 1, "Create_options",
-   OPEN_FRM_ONLY),
-  ColumnInfo("TABLE_COMMENT", TABLE_COMMENT_MAXLEN, DRIZZLE_TYPE_VARCHAR,
-            0, 0, "Comment", OPEN_FRM_ONLY),
-  ColumnInfo()
-};
-
-
-ColumnInfo columns_fields_info[]=
-{
-  ColumnInfo("TABLE_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FRM_ONLY),
-  ColumnInfo("TABLE_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FRM_ONLY),
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FRM_ONLY),
-  ColumnInfo("COLUMN_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Field",
-   OPEN_FRM_ONLY),
-  ColumnInfo("ORDINAL_POSITION", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0,
-   MY_I_S_UNSIGNED, "", OPEN_FRM_ONLY),
-  ColumnInfo("COLUMN_DEFAULT", MAX_FIELD_VARCHARLENGTH, DRIZZLE_TYPE_VARCHAR, 0,
-   1, "Default", OPEN_FRM_ONLY),
-  ColumnInfo("IS_NULLABLE", 3, DRIZZLE_TYPE_VARCHAR, 0, 0, "Null", OPEN_FRM_ONLY),
-  ColumnInfo("DATA_TYPE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FRM_ONLY),
-  ColumnInfo("CHARACTER_MAXIMUM_LENGTH", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG,
-   0, (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "", OPEN_FRM_ONLY),
-  ColumnInfo("CHARACTER_OCTET_LENGTH", MY_INT64_NUM_DECIMAL_DIGITS , DRIZZLE_TYPE_LONGLONG,
-   0, (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "", OPEN_FRM_ONLY),
-  ColumnInfo("NUMERIC_PRECISION", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG,
-   0, (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "", OPEN_FRM_ONLY),
-  ColumnInfo("NUMERIC_SCALE", MY_INT64_NUM_DECIMAL_DIGITS , DRIZZLE_TYPE_LONGLONG,
-   0, (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED), "", OPEN_FRM_ONLY),
-  ColumnInfo("CHARACTER_SET_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FRM_ONLY),
-  ColumnInfo("COLLATION_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 1, "Collation", OPEN_FRM_ONLY),
-  ColumnInfo("COLUMN_TYPE", 65535, DRIZZLE_TYPE_VARCHAR, 0, 0, "Type", OPEN_FRM_ONLY),
-  ColumnInfo("COLUMN_KEY", 3, DRIZZLE_TYPE_VARCHAR, 0, 0, "Key", OPEN_FRM_ONLY),
-  ColumnInfo("EXTRA", 27, DRIZZLE_TYPE_VARCHAR, 0, 0, "Extra", OPEN_FRM_ONLY),
-  ColumnInfo("PRIVILEGES", 80, DRIZZLE_TYPE_VARCHAR, 0, 0, "Privileges", OPEN_FRM_ONLY),
-  ColumnInfo("COLUMN_COMMENT", COLUMN_COMMENT_MAXLEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Comment", OPEN_FRM_ONLY),
-  ColumnInfo("STORAGE", 8, DRIZZLE_TYPE_VARCHAR, 0, 0, "Storage", OPEN_FRM_ONLY),
-  ColumnInfo("FORMAT", 8, DRIZZLE_TYPE_VARCHAR, 0, 0, "Format", OPEN_FRM_ONLY),
-  ColumnInfo()
-};
-
-
-ColumnInfo collation_fields_info[]=
-{
-  ColumnInfo("COLLATION_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "Collation", SKIP_OPEN_TABLE),
-  ColumnInfo("CHARACTER_SET_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "Charset",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("ID", MY_INT32_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0, 0, "Id",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("IS_DEFAULT", 3, DRIZZLE_TYPE_VARCHAR, 0, 0, "Default", SKIP_OPEN_TABLE),
-  ColumnInfo("IS_COMPILED", 3, DRIZZLE_TYPE_VARCHAR, 0, 0, "Compiled", SKIP_OPEN_TABLE),
-  ColumnInfo("SORTLEN", 3, DRIZZLE_TYPE_LONGLONG, 0, 0, "Sortlen", SKIP_OPEN_TABLE),
-  ColumnInfo()
-};
-
-
-
-ColumnInfo coll_charset_app_fields_info[]=
-{
-  ColumnInfo("COLLATION_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "", SKIP_OPEN_TABLE),
-  ColumnInfo("CHARACTER_SET_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "", SKIP_OPEN_TABLE),
-  ColumnInfo()
-};
-
-
-ColumnInfo stat_fields_info[]=
-{
-  ColumnInfo("TABLE_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FRM_ONLY),
-  ColumnInfo("TABLE_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FRM_ONLY),
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Table", OPEN_FRM_ONLY),
-  ColumnInfo("NON_UNIQUE", 1, DRIZZLE_TYPE_LONGLONG, 0, 0, "Non_unique", OPEN_FRM_ONLY),
-  ColumnInfo("INDEX_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FRM_ONLY),
-  ColumnInfo("INDEX_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Key_name",
-   OPEN_FRM_ONLY),
-  ColumnInfo("SEQ_IN_INDEX", 2, DRIZZLE_TYPE_LONGLONG, 0, 0, "Seq_in_index", OPEN_FRM_ONLY),
-  ColumnInfo("COLUMN_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Column_name",
-   OPEN_FRM_ONLY),
-  ColumnInfo("COLLATION", 1, DRIZZLE_TYPE_VARCHAR, 0, 1, "Collation", OPEN_FRM_ONLY),
-  ColumnInfo("CARDINALITY", MY_INT64_NUM_DECIMAL_DIGITS, DRIZZLE_TYPE_LONGLONG, 0, 1,
-   "Cardinality", OPEN_FULL_TABLE),
-  ColumnInfo("SUB_PART", 3, DRIZZLE_TYPE_LONGLONG, 0, 1, "Sub_part", OPEN_FRM_ONLY),
-  ColumnInfo("PACKED", 10, DRIZZLE_TYPE_VARCHAR, 0, 1, "Packed", OPEN_FRM_ONLY),
-  ColumnInfo("NULLABLE", 3, DRIZZLE_TYPE_VARCHAR, 0, 0, "Null", OPEN_FRM_ONLY),
-  ColumnInfo("INDEX_TYPE", 16, DRIZZLE_TYPE_VARCHAR, 0, 0, "Index_type", OPEN_FULL_TABLE),
-  ColumnInfo("COMMENT", 16, DRIZZLE_TYPE_VARCHAR, 0, 1, "Comment", OPEN_FRM_ONLY),
-  ColumnInfo("INDEX_COMMENT", INDEX_COMMENT_MAXLEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Index_Comment", OPEN_FRM_ONLY),
-  ColumnInfo()
-};
-
-
-ColumnInfo table_names_fields_info[]=
-{
-  ColumnInfo("TABLE_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", SKIP_OPEN_TABLE),
-  ColumnInfo("TABLE_SCHEMA",NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", SKIP_OPEN_TABLE),
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Tables_in_",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("TABLE_TYPE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Table_type",
-   OPEN_FRM_ONLY),
-  ColumnInfo()
-};
-
-
-ColumnInfo open_tables_fields_info[]=
-{
-  ColumnInfo("Database", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Database",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("Table",NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Table", SKIP_OPEN_TABLE),
-  ColumnInfo("In_use", 1, DRIZZLE_TYPE_LONGLONG, 0, 0, "In_use", SKIP_OPEN_TABLE),
-  ColumnInfo("Name_locked", 4, DRIZZLE_TYPE_LONGLONG, 0, 0, "Name_locked", SKIP_OPEN_TABLE),
-  ColumnInfo()
-};
-
-
 ColumnInfo variables_fields_info[]=
 {
   ColumnInfo("VARIABLE_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "Variable_name",
@@ -3688,19 +3034,9 @@
 };
 
 
-static ColumnsISMethods columns_methods;
 static StatusISMethods status_methods;
 static VariablesISMethods variables_methods;
-static OpenTablesISMethods open_tables_methods;
-static SchemataISMethods schemata_methods;
-static StatsISMethods stats_methods;
-static TablesISMethods tables_methods;
-static TabNamesISMethods tab_names_methods;
 
-static InfoSchemaTable columns_table("COLUMNS",
-                                     columns_fields_info,
-                                     1, 2, false, true, OPTIMIZE_I_S_TABLE,
-                                     &columns_methods);
 static InfoSchemaTable global_stat_table("GLOBAL_STATUS",
                                          variables_fields_info,
                                          -1, -1, false, false, 0,
@@ -3709,14 +3045,6 @@
                                         variables_fields_info,
                                         -1, -1, false, false, 0,
                                         &variables_methods);
-static InfoSchemaTable open_tab_table("OPEN_TABLES",
-                                      open_tables_fields_info,
-                                      -1, -1, true, false, 0,
-                                      &open_tables_methods);
-static InfoSchemaTable schemata_table("SCHEMATA",
-                                      schema_fields_info,
-                                      1, -1, false, false, 0,
-                                      &schemata_methods);
 static InfoSchemaTable sess_stat_table("SESSION_STATUS",
                                        variables_fields_info,
                                        -1, -1, false, false, 0,
@@ -3725,23 +3053,10 @@
                                       variables_fields_info,
                                       -1, -1, false, false, 0,
                                       &variables_methods);
-static InfoSchemaTable stats_table("STATISTICS",
-                                   stat_fields_info,
-                                   1, 2, false, true,
-                                   OPEN_TABLE_ONLY|OPTIMIZE_I_S_TABLE,
-                                   &stats_methods);
 static InfoSchemaTable status_table("STATUS",
                                     variables_fields_info,
                                     -1, -1, true, false, 0,
                                     &status_methods);
-static InfoSchemaTable tables_table("TABLES",
-                                    tables_fields_info,
-                                    1, 2, false, true, OPTIMIZE_I_S_TABLE,
-                                    &tables_methods);
-static InfoSchemaTable tab_names_table("TABLE_NAMES",
-                                       table_names_fields_info,
-                                       1, 2, true, true, 0,
-                                       &tab_names_methods);
 static InfoSchemaTable var_table("VARIABLES",
                                  variables_fields_info,
                                  -1, -1, true, false, 0,
@@ -3749,17 +3064,11 @@
 
 InfoSchemaTable schema_tables[]=
 {
-  columns_table,
   global_stat_table,
   global_var_table,
-  open_tab_table,
-  schemata_table,
   sess_stat_table,
   sess_var_table,
-  stats_table,
   status_table,
-  tables_table,
-  tab_names_table,
   var_table,
   InfoSchemaTable()
 };

=== modified file 'drizzled/show.h'
--- drizzled/show.h	2009-06-29 17:24:02 +0000
+++ drizzled/show.h	2009-07-01 02:01:37 +0000
@@ -49,9 +49,21 @@
   FIND_FILES_DIR
 };
 
+typedef struct st_lookup_field_values
+{
+  LEX_STRING db_value, table_value;
+  bool wild_db_value, wild_table_value;
+} LOOKUP_FIELD_VALUES;
+
 find_files_result find_files(Session *session, List<LEX_STRING> *files, const char *db,
                              const char *path, const char *wild, bool dir);
-
+bool calc_lookup_values_from_cond(Session *session, COND *cond, TableList *table,
+                                  LOOKUP_FIELD_VALUES *lookup_field_vals);
+bool get_lookup_field_values(Session *session, COND *cond, TableList *tables,
+                             LOOKUP_FIELD_VALUES *lookup_field_values);
+int make_db_list(Session *session, List<LEX_STRING> *files,
+                 LOOKUP_FIELD_VALUES *lookup_field_vals,
+                 bool *with_i_schema);
 
 int store_create_info(TableList *table_list, String *packet, HA_CREATE_INFO  *create_info_arg);
 bool store_db_create_info(const char *dbname, String *buffer, HA_CREATE_INFO *create_info);

=== modified file 'plugin/info_schema/info_schema.cc'
--- plugin/info_schema/info_schema.cc	2009-06-29 16:05:47 +0000
+++ plugin/info_schema/info_schema.cc	2009-07-01 03:36:14 +0000
@@ -30,6 +30,8 @@
 #include "info_schema_methods.h"
 #include "info_schema_columns.h"
 
+#include <vector>
+
 using namespace std;
 
 /*
@@ -38,11 +40,17 @@
 static vector<const ColumnInfo *> char_set_columns;
 static vector<const ColumnInfo *> collation_columns;
 static vector<const ColumnInfo *> coll_char_columns;
+static vector<const ColumnInfo *> col_columns;
 static vector<const ColumnInfo *> key_col_usage_columns;
+static vector<const ColumnInfo *> open_tab_columns;
 static vector<const ColumnInfo *> plugin_columns;
 static vector<const ColumnInfo *> processlist_columns;
 static vector<const ColumnInfo *> ref_constraint_columns;
+static vector<const ColumnInfo *> schemata_columns;
+static vector<const ColumnInfo *> stats_columns;
 static vector<const ColumnInfo *> tab_constraints_columns;
+static vector<const ColumnInfo *> tables_columns;
+static vector<const ColumnInfo *> tab_names_columns;
 
 /*
  * Methods for various I_S tables.
@@ -50,11 +58,17 @@
 static InfoSchemaMethods *char_set_methods= NULL;
 static InfoSchemaMethods *collation_methods= NULL;
 static InfoSchemaMethods *coll_char_methods= NULL;
+static InfoSchemaMethods *columns_methods= NULL;
 static InfoSchemaMethods *key_col_usage_methods= NULL;
+static InfoSchemaMethods *open_tab_methods= NULL;
 static InfoSchemaMethods *plugins_methods= NULL;
 static InfoSchemaMethods *processlist_methods= NULL;
 static InfoSchemaMethods *ref_constraint_methods= NULL;
+static InfoSchemaMethods *schemata_methods= NULL;
+static InfoSchemaMethods *stats_methods= NULL;
 static InfoSchemaMethods *tab_constraints_methods= NULL;
+static InfoSchemaMethods *tables_methods= NULL;
+static InfoSchemaMethods *tab_names_methods= NULL;
 
 /*
  * I_S tables.
@@ -62,11 +76,17 @@
 static InfoSchemaTable *char_set_table= NULL;
 static InfoSchemaTable *collation_table= NULL;
 static InfoSchemaTable *coll_char_set_table= NULL;
+static InfoSchemaTable *columns_table= NULL;
 static InfoSchemaTable *key_col_usage_table= NULL;
+static InfoSchemaTable *open_tab_table= NULL;
 static InfoSchemaTable *plugins_table= NULL;
 static InfoSchemaTable *processlist_table= NULL;
 static InfoSchemaTable *ref_constraint_table= NULL;
+static InfoSchemaTable *schemata_table= NULL;
+static InfoSchemaTable *stats_table= NULL;
 static InfoSchemaTable *tab_constraints_table= NULL;
+static InfoSchemaTable *tables_table= NULL;
+static InfoSchemaTable *tab_names_table= NULL;
 
 /**
  * Populate the vectors of columns for each I_S table.
@@ -92,11 +112,21 @@
     return true;
   }
 
+  if ((retval= createColColumns(col_columns)) == true)
+  {
+    return true;
+  }
+
   if ((retval= createKeyColUsageColumns(key_col_usage_columns)) == true)
   {
     return true;
   }
 
+  if ((retval= createOpenTabColumns(open_tab_columns)) == true)
+  {
+    return true;
+  }
+
   if ((retval= createPluginsColumns(plugin_columns)) == true)
   {
     return true;
@@ -112,11 +142,31 @@
     return true;
   }
 
+  if ((retval= createSchemataColumns(schemata_columns)) == true)
+  {
+    return true;
+  }
+
+  if ((retval= createStatsColumns(stats_columns)) == true)
+  {
+    return true;
+  }
+
   if ((retval= createTabConstraintsColumns(tab_constraints_columns)) == true)
   {
     return true;
   }
 
+  if ((retval= createTablesColumns(tables_columns)) == true)
+  {
+    return true;
+  }
+
+  if ((retval= createTabNamesColumns(tab_names_columns)) == true)
+  {
+    return true;
+  }
+
   return false;
 }
 
@@ -128,11 +178,17 @@
   clearColumns(char_set_columns);
   clearColumns(collation_columns);
   clearColumns(coll_char_columns);
+  clearColumns(col_columns);
   clearColumns(key_col_usage_columns);
+  clearColumns(open_tab_columns);
   clearColumns(plugin_columns);
   clearColumns(processlist_columns);
   clearColumns(ref_constraint_columns);
+  clearColumns(schemata_columns);
+  clearColumns(stats_columns);
   clearColumns(tab_constraints_columns);
+  clearColumns(tables_columns);
+  clearColumns(tab_names_columns);
 }
 
 /**
@@ -157,11 +213,21 @@
     return true;
   }
 
+  if ((columns_methods= new(std::nothrow) ColumnsISMethods()) == NULL)
+  {
+    return true;
+  }
+
   if ((key_col_usage_methods= new(std::nothrow) KeyColUsageISMethods()) == NULL)
   {
     return true;
   }
 
+  if ((open_tab_methods= new(std::nothrow) OpenTablesISMethods()) == NULL)
+  {
+    return true;
+  }
+
   if ((plugins_methods= new(std::nothrow) PluginsISMethods()) == NULL)
   {
     return true;
@@ -177,11 +243,31 @@
     return true;
   }
 
+  if ((schemata_methods= new(std::nothrow) SchemataISMethods()) == NULL)
+  {
+    return true;
+  }
+
+  if ((stats_methods= new(std::nothrow) StatsISMethods()) == NULL)
+  {
+    return true;
+  }
+
   if ((tab_constraints_methods= new(std::nothrow) TabConstraintsISMethods()) == NULL)
   {
     return true;
   }
 
+  if ((tables_methods= new(std::nothrow) TablesISMethods()) == NULL)
+  {
+    return true;
+  }
+
+  if ((tab_names_methods= new(std::nothrow) TabNamesISMethods()) == NULL)
+  {
+    return true;
+  }
+
   return false;
 }
 
@@ -193,11 +279,17 @@
   delete char_set_methods;
   delete collation_methods;
   delete coll_char_methods;
+  delete columns_methods;
   delete key_col_usage_methods;
+  delete open_tab_methods;
   delete plugins_methods;
   delete processlist_methods;
   delete ref_constraint_methods;
+  delete schemata_methods;
+  delete stats_methods;
   delete tab_constraints_methods;
+  delete tables_methods;
+  delete tab_names_methods;
 }
 
 /**
@@ -235,6 +327,16 @@
     return true;
   }
 
+  columns_table= new(std::nothrow) InfoSchemaTable("COLUMNS",
+                                                   col_columns,
+                                                   1, 2, false, true,
+                                                   OPTIMIZE_I_S_TABLE,
+                                                   columns_methods);
+  if (columns_table == NULL)
+  {
+    return true;
+  }
+
   key_col_usage_table= new(std::nothrow) InfoSchemaTable("KEY_COLUMN_USAGE",
                                                          key_col_usage_columns,
                                                          4, 5, false, true,
@@ -245,6 +347,15 @@
     return true;
   }
 
+  open_tab_table= new(std::nothrow) InfoSchemaTable("OPEN_TABLES",
+                                                    open_tab_columns,
+                                                    -1, -1, true, false, 0,
+                                                    open_tab_methods);
+  if (open_tab_table == NULL)
+  {
+    return true;
+  }
+
   plugins_table= new(std::nothrow) InfoSchemaTable("PLUGINS",
                                                    plugin_columns,
                                                    -1, -1, false, false, 0,
@@ -273,6 +384,25 @@
     return true;
   }
 
+  schemata_table= new(std::nothrow) InfoSchemaTable("SCHEMATA",
+                                                    schemata_columns,
+                                                    1, -1, false, false, 0,
+                                                    schemata_methods);
+  if (schemata_table == NULL)
+  {
+    return true;
+  }
+
+  stats_table= new(std::nothrow) InfoSchemaTable("STATISTICS",
+                                                 stats_columns,
+                                                 1, 2, false, true,
+                                                 OPEN_TABLE_ONLY | OPTIMIZE_I_S_TABLE,
+                                                 stats_methods);
+  if (stats_table == NULL)
+  {
+    return true;
+  }
+
   tab_constraints_table= new(std::nothrow) InfoSchemaTable("TABLE_CONSTRAINTS",
                                                            tab_constraints_columns,
                                                            3, 4, false, true,
@@ -283,6 +413,25 @@
     return true;
   }
 
+  tables_table= new(std::nothrow) InfoSchemaTable("TABLES",
+                                                  tables_columns,
+                                                  1, 2, false, true,
+                                                  OPTIMIZE_I_S_TABLE,
+                                                  tables_methods);
+  if (tables_table == NULL)
+  {
+    return true;
+  }
+
+  tab_names_table= new(std::nothrow) InfoSchemaTable("TABLE_NAMES",
+                                                     tab_names_columns,
+                                                     1, 2, true, true, 0,
+                                                     tab_names_methods);
+  if (tab_names_table == NULL)
+  {
+    return true;
+  }
+
   return false;
 }
 
@@ -294,11 +443,17 @@
   delete char_set_table;
   delete collation_table;
   delete coll_char_set_table;
+  delete columns_table;
   delete key_col_usage_table;
+  delete open_tab_table;
   delete plugins_table;
   delete processlist_table;
   delete ref_constraint_table;
+  delete schemata_table;
+  delete stats_table;
   delete tab_constraints_table;
+  delete tables_table;
+  delete tab_names_table;
 }
 
 /**
@@ -329,11 +484,17 @@
   registry.add(char_set_table);
   registry.add(collation_table);
   registry.add(coll_char_set_table);
+  registry.add(columns_table);
   registry.add(key_col_usage_table);
+  registry.add(open_tab_table);
   registry.add(plugins_table);
   registry.add(processlist_table);
   registry.add(ref_constraint_table);
+  registry.add(schemata_table);
+  registry.add(stats_table);
   registry.add(tab_constraints_table);
+  registry.add(tables_table);
+  registry.add(tab_names_table);
 
   return 0;
 }
@@ -349,11 +510,17 @@
   registry.remove(char_set_table);
   registry.remove(collation_table);
   registry.remove(coll_char_set_table);
+  registry.remove(columns_table);
   registry.remove(key_col_usage_table);
+  registry.remove(open_tab_table);
   registry.remove(plugins_table);
   registry.remove(processlist_table);
   registry.remove(ref_constraint_table);
+  registry.remove(schemata_table);
+  registry.remove(stats_table);
   registry.remove(tab_constraints_table);
+  registry.remove(tables_table);
+  registry.remove(tab_names_table);
 
   cleanupTableMethods();
   cleanupTableColumns();

=== modified file 'plugin/info_schema/info_schema_columns.cc'
--- plugin/info_schema/info_schema_columns.cc	2009-06-29 16:05:47 +0000
+++ plugin/info_schema/info_schema_columns.cc	2009-07-01 03:36:14 +0000
@@ -239,6 +239,291 @@
   return false;
 }
 
+bool createColColumns(vector<const ColumnInfo *>& cols)
+{
+  /*
+   * Create each column for the COLUMNS table.
+   */
+  const ColumnInfo *tab_cat= new(std::nothrow) ColumnInfo("TABLE_CATALOG",
+                                                          FN_REFLEN,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          1,
+                                                          "",
+                                                          OPEN_FRM_ONLY);
+  if (tab_cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_sch= new(std::nothrow) ColumnInfo("TABLE_SCHEMA",
+                                                          NAME_CHAR_LEN,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          0,
+                                                          "",
+                                                          OPEN_FRM_ONLY);
+  if (tab_sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FRM_ONLY);
+  if (tab_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_name= new(std::nothrow) ColumnInfo("COLUMN_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "Field",
+                                                           OPEN_FRM_ONLY);
+  if (col_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *ord_pos= new(std::nothrow) ColumnInfo("ORDINAL_POSITION",
+                                                          MY_INT64_NUM_DECIMAL_DIGITS,
+                                                          DRIZZLE_TYPE_LONGLONG,
+                                                          0,
+                                                          MY_I_S_UNSIGNED,
+                                                          "",
+                                                          OPEN_FRM_ONLY);
+  if (ord_pos == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_def= new(std::nothrow) ColumnInfo("COLUMN_DEFAULT",
+                                                          MAX_FIELD_VARCHARLENGTH,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          1,
+                                                          "Default",
+                                                          OPEN_FRM_ONLY);
+  if (col_def == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *is_nullable= new(std::nothrow) ColumnInfo("IS_NULLABLE",
+                                                              3,
+                                                              DRIZZLE_TYPE_VARCHAR,
+                                                              0,
+                                                              0,
+                                                              "Null",
+                                                              OPEN_FRM_ONLY);
+  if (is_nullable == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *data_type= new(std::nothrow) ColumnInfo("DATA_TYPE",
+                                                            NAME_CHAR_LEN,
+                                                            DRIZZLE_TYPE_VARCHAR,
+                                                            0,
+                                                            0,
+                                                            "",
+                                                            OPEN_FRM_ONLY);
+  if (data_type == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *max_len= new(std::nothrow) ColumnInfo("CHARACTER_MAXIMUM_LENGTH",
+                                                          MY_INT64_NUM_DECIMAL_DIGITS,
+                                                          DRIZZLE_TYPE_LONGLONG,
+                                                          0,
+                                                          (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                          "",
+                                                          OPEN_FRM_ONLY);
+  if (max_len == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *octet_len= new(std::nothrow) ColumnInfo("CHARACTER_OCTET_LENGTH",
+                                                            MY_INT64_NUM_DECIMAL_DIGITS,
+                                                            DRIZZLE_TYPE_LONGLONG,
+                                                            0,
+                                                            (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                            "",
+                                                            OPEN_FRM_ONLY);
+  if (octet_len == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *num_prec= new(std::nothrow) ColumnInfo("NUMERIC_PRECISION",
+                                                           MY_INT64_NUM_DECIMAL_DIGITS,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                           "",
+                                                           OPEN_FRM_ONLY);
+  if (num_prec == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *num_scale= new(std::nothrow) ColumnInfo("NUMERIC_SCALE",
+                                                            MY_INT64_NUM_DECIMAL_DIGITS,
+                                                            DRIZZLE_TYPE_LONGLONG,
+                                                            0,
+                                                            (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                            "",
+                                                            OPEN_FRM_ONLY);
+  if (num_scale == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *char_set_name= new(std::nothrow) ColumnInfo("CHARACTER_SET_NAME",
+                                                                64,
+                                                                DRIZZLE_TYPE_VARCHAR,
+                                                                0,
+                                                                1,
+                                                                "",
+                                                                OPEN_FRM_ONLY);
+  if (char_set_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *coll_name= new(std::nothrow) ColumnInfo("COLLATION_NAME",
+                                                            64,
+                                                            DRIZZLE_TYPE_VARCHAR,
+                                                            0,
+                                                            1,
+                                                            "Collation",
+                                                            OPEN_FRM_ONLY);
+  if (coll_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_type= new(std::nothrow) ColumnInfo("COLUMN_TYPE",
+                                                           65535,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "Type",
+                                                           OPEN_FRM_ONLY);
+  if (col_type == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_key= new(std::nothrow) ColumnInfo("COLUMN_KEY",
+                                                          3,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          0,
+                                                          "Key",
+                                                          OPEN_FRM_ONLY);
+  if (col_key == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *extra= new(std::nothrow) ColumnInfo("EXTRA",
+                                                        27,
+                                                        DRIZZLE_TYPE_VARCHAR,
+                                                        0,
+                                                        0,
+                                                        "Extra",
+                                                        OPEN_FRM_ONLY);
+  if (extra == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *priv= new(std::nothrow) ColumnInfo("PRIVILEGES",
+                                                       80,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Privileges",
+                                                       OPEN_FRM_ONLY);
+  if (priv == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_comment= new(std::nothrow) ColumnInfo("COLUMN_COMMENT",
+                                                              COLUMN_COMMENT_MAXLEN,
+                                                              DRIZZLE_TYPE_VARCHAR,
+                                                              0,
+                                                              0,
+                                                              "Comment",
+                                                              OPEN_FRM_ONLY);
+  if (col_comment == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *storage= new(std::nothrow) ColumnInfo("STORAGE",
+                                                          8,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          0,
+                                                          "Storage",
+                                                          OPEN_FRM_ONLY);
+  if (storage == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *format= new(std::nothrow) ColumnInfo("FORMAT",
+                                                         8,
+                                                         DRIZZLE_TYPE_VARCHAR,
+                                                         0,
+                                                         0,
+                                                         "Format",
+                                                         OPEN_FRM_ONLY);
+  if (format == NULL)
+  {
+    return true;
+  }
+
+  /*
+   * Add the columns to the vector.
+   */
+  cols.push_back(tab_cat);
+  cols.push_back(tab_sch);
+  cols.push_back(tab_name);
+  cols.push_back(col_name);
+  cols.push_back(ord_pos);
+  cols.push_back(col_def);
+  cols.push_back(is_nullable);
+  cols.push_back(data_type);
+  cols.push_back(max_len);
+  cols.push_back(octet_len);
+  cols.push_back(num_prec);
+  cols.push_back(num_scale);
+  cols.push_back(char_set_name);
+  cols.push_back(coll_name);
+  cols.push_back(col_type);
+  cols.push_back(col_key);
+  cols.push_back(extra);
+  cols.push_back(priv);
+  cols.push_back(col_comment);
+  cols.push_back(storage);
+  cols.push_back(format);
+
+  return false;
+}
+
 bool createKeyColUsageColumns(vector<const ColumnInfo *>& cols)
 {
   const ColumnInfo *cat= new(std::nothrow) ColumnInfo("CONSTRAINT_CATALOG",
@@ -400,6 +685,64 @@
   return false;
 }
 
+bool createOpenTabColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *db= new(std::nothrow) ColumnInfo("Database",
+                                                     NAME_CHAR_LEN,
+                                                     DRIZZLE_TYPE_VARCHAR,
+                                                     0,
+                                                     0,
+                                                     "Database",
+                                                     SKIP_OPEN_TABLE);
+  if (db == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab= new(std::nothrow) ColumnInfo("Table",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "Table",
+                                                      SKIP_OPEN_TABLE);
+  if (tab == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *in_use= new(std::nothrow) ColumnInfo("In_use",
+                                                         1,
+                                                         DRIZZLE_TYPE_LONGLONG,
+                                                         0,
+                                                         0,
+                                                         "In_use",
+                                                         SKIP_OPEN_TABLE);
+  if (in_use == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *name_locked= new(std::nothrow) ColumnInfo("Name_locked",
+                                                              4,
+                                                              DRIZZLE_TYPE_LONGLONG,
+                                                              0,
+                                                              0,
+                                                              "Name_locked",
+                                                              SKIP_OPEN_TABLE);
+  if (name_locked == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(db);
+  cols.push_back(tab);
+  cols.push_back(in_use);
+  cols.push_back(name_locked);
+
+  return false;
+}
+
 bool createPluginsColumns(vector<const ColumnInfo *>& cols)
 {
   const ColumnInfo *name= new(std::nothrow) ColumnInfo("PLUGIN_NAME",
@@ -756,6 +1099,291 @@
   return false;
 }
 
+bool createSchemataColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *cat_name= new(std::nothrow) ColumnInfo("CATALOG_NAME",
+                                                           FN_REFLEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0, 
+                                                           1, 
+                                                           "", 
+                                                           SKIP_OPEN_TABLE);
+  if (cat_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch_name= new(std::nothrow) ColumnInfo("SCHEMA_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0, 
+                                                           0, 
+                                                           "Database", 
+                                                           SKIP_OPEN_TABLE);
+  if (sch_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *cs_name= new(std::nothrow) ColumnInfo("DEFAULT_CHARACTER_SET_NAME",
+                                                          64, 
+                                                          DRIZZLE_TYPE_VARCHAR, 
+                                                          0, 
+                                                          0, 
+                                                          "",
+                                                          SKIP_OPEN_TABLE);
+  if (cs_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *coll_name= new(std::nothrow) ColumnInfo("DEFAULT_COLLATION_NAME",
+                                                            64, 
+                                                            DRIZZLE_TYPE_VARCHAR, 
+                                                            0, 
+                                                            0, 
+                                                            "",
+                                                            SKIP_OPEN_TABLE);
+  if (coll_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sql_path= new(std::nothrow) ColumnInfo("SQL_PATH",
+                                                           FN_REFLEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0, 
+                                                           1, 
+                                                           "", 
+                                                           SKIP_OPEN_TABLE);
+  if (sql_path == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(cat_name);
+  cols.push_back(sch_name);
+  cols.push_back(cs_name);
+  cols.push_back(coll_name);
+  cols.push_back(sql_path);
+
+  return false;
+}
+
+bool createStatsColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *cat= new(std::nothrow) ColumnInfo("TABLE_CATALOG",
+                                                      FN_REFLEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      OPEN_FRM_ONLY);
+  if (cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch= new(std::nothrow) ColumnInfo("TABLE_SCHEMA",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      OPEN_FRM_ONLY);
+  if (sch == NULL)
+  {
+    return true;
+  }
+  
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Table",
+                                                       OPEN_FRM_ONLY);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *uniq= new(std::nothrow) ColumnInfo("NON_UNIQUE",
+                                                       1,
+                                                       DRIZZLE_TYPE_LONGLONG,
+                                                       0,
+                                                       0,
+                                                       "Non_unique",
+                                                       OPEN_FRM_ONLY);
+  if (uniq == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *idx_sch= new(std::nothrow) ColumnInfo("INDEX_SCHEMA",
+                                                          NAME_CHAR_LEN,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          0,
+                                                          "",
+                                                          OPEN_FRM_ONLY);
+  if (idx_sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *idx_name= new(std::nothrow) ColumnInfo("INDEX_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "Key_name",
+                                                           OPEN_FRM_ONLY);
+  if (idx_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *seq_in_idx= new(std::nothrow) ColumnInfo("SEQ_IN_INDEX",
+                                                             2,
+                                                             DRIZZLE_TYPE_LONGLONG,
+                                                             0,
+                                                             0,
+                                                             "Seq_in_index",
+                                                             OPEN_FRM_ONLY);
+  if (seq_in_idx == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_name= new(std::nothrow) ColumnInfo("COLUMN_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "Column_name",
+                                                           OPEN_FRM_ONLY);
+  if (col_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *coll= new(std::nothrow) ColumnInfo("COLLATION",
+                                                       1,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       1,
+                                                       "Collation",
+                                                       OPEN_FRM_ONLY);
+  if (coll == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *card= new(std::nothrow) ColumnInfo("CARDINALITY",
+                                                       MY_INT64_NUM_DECIMAL_DIGITS,
+                                                       DRIZZLE_TYPE_LONGLONG,
+                                                       0,
+                                                       1,
+                                                       "Cardinality",
+                                                       OPEN_FULL_TABLE);
+  if (card == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sub_part= new(std::nothrow) ColumnInfo("SUB_PART",
+                                                           3,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           1,
+                                                           "Sub_part",
+                                                           OPEN_FRM_ONLY);
+  if (sub_part == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *packed= new(std::nothrow) ColumnInfo("PACKED",
+                                                         10,
+                                                         DRIZZLE_TYPE_VARCHAR,
+                                                         0,
+                                                         1,
+                                                         "Packed",
+                                                         OPEN_FRM_ONLY);
+  if (packed == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *nullable= new(std::nothrow) ColumnInfo("NULLABLE",
+                                                           3,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "Null",
+                                                           OPEN_FRM_ONLY);
+  if (nullable == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *idx_type= new(std::nothrow) ColumnInfo("INDEX_TYPE",
+                                                           16,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "Index_type",
+                                                           OPEN_FULL_TABLE);
+  if (idx_type == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *comment= new(std::nothrow) ColumnInfo("COMMENT",
+                                                          16,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          1,
+                                                          "Comment",
+                                                          OPEN_FRM_ONLY);
+  if (comment == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *idx_comment= new(std::nothrow) ColumnInfo("INDEX_COMMENT",
+                                                              INDEX_COMMENT_MAXLEN,
+                                                              DRIZZLE_TYPE_VARCHAR,
+                                                              0,
+                                                              0,
+                                                              "Index_Comment",
+                                                              OPEN_FRM_ONLY);
+  if (idx_comment == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(cat);
+  cols.push_back(sch);
+  cols.push_back(name);
+  cols.push_back(uniq);
+  cols.push_back(idx_sch);
+  cols.push_back(idx_name);
+  cols.push_back(seq_in_idx);
+  cols.push_back(col_name);
+  cols.push_back(coll);
+  cols.push_back(card);
+  cols.push_back(sub_part);
+  cols.push_back(packed);
+  cols.push_back(nullable);
+  cols.push_back(idx_type);
+  cols.push_back(comment);
+  cols.push_back(idx_comment);
+
+  return false;
+}
+
 bool createTabConstraintsColumns(vector<const ColumnInfo *>& cols)
 {
   const ColumnInfo *cat= new(std::nothrow) ColumnInfo("CONSTRAINT_CATALOG",
@@ -840,6 +1468,344 @@
   return false;
 }
 
+bool createTablesColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *cat= new(std::nothrow) ColumnInfo("TABLE_CATALOG",
+                                                      FN_REFLEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      SKIP_OPEN_TABLE);
+  if (cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch= new(std::nothrow) ColumnInfo("TABLE_SCHEMA",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      SKIP_OPEN_TABLE);
+  if (sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Name",
+                                                       SKIP_OPEN_TABLE);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *type= new(std::nothrow) ColumnInfo("TABLE_TYPE",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "",
+                                                       OPEN_FRM_ONLY);
+  if (type == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *engine= new(std::nothrow) ColumnInfo("ENGINE",
+                                                         NAME_CHAR_LEN,
+                                                         DRIZZLE_TYPE_VARCHAR,
+                                                         0,
+                                                         1,
+                                                         "Engine",
+                                                         OPEN_FRM_ONLY);
+  if (engine == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *version= new(std::nothrow) ColumnInfo("VERSION",
+                                                          MY_INT64_NUM_DECIMAL_DIGITS,
+                                                          DRIZZLE_TYPE_LONGLONG,
+                                                          0,
+                                                          (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                          "Version",
+                                                          OPEN_FRM_ONLY);
+  if (version == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *row_format= new(std::nothrow) ColumnInfo("ROW_FORMAT",
+                                                             10,
+                                                             DRIZZLE_TYPE_VARCHAR,
+                                                             0,
+                                                             1,
+                                                             "Row_format",
+                                                             OPEN_FULL_TABLE);
+  if (row_format == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_rows= new(std::nothrow) ColumnInfo("TABLE_ROWS",
+                                                           MY_INT64_NUM_DECIMAL_DIGITS,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                           "Rows",
+                                                           OPEN_FULL_TABLE);
+  if (tab_rows == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *avg_row_len= new(std::nothrow) ColumnInfo("AVG_ROW_LENGTH",
+                                                              MY_INT64_NUM_DECIMAL_DIGITS,
+                                                              DRIZZLE_TYPE_LONGLONG,
+                                                              0,
+                                                              (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                              "Avg_row_length",
+                                                              OPEN_FULL_TABLE);
+  if (avg_row_len == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *data_len= new(std::nothrow) ColumnInfo("DATA_LENGTH",
+                                                           MY_INT64_NUM_DECIMAL_DIGITS,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                           "Data_length",
+                                                           OPEN_FULL_TABLE);
+  if (data_len == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *max_data_len= new(std::nothrow) ColumnInfo("MAX_DATA_LENGTH",
+                                                               MY_INT64_NUM_DECIMAL_DIGITS,
+                                                               DRIZZLE_TYPE_LONGLONG,
+                                                               0,
+                                                               (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                               "Max_data_length",
+                                                               OPEN_FULL_TABLE);
+  if (max_data_len == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *idx_len= new(std::nothrow) ColumnInfo("INDEX_LENGTH",
+                                                          MY_INT64_NUM_DECIMAL_DIGITS,
+                                                          DRIZZLE_TYPE_LONGLONG,
+                                                          0,
+                                                          (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                          "Index_length",
+                                                          OPEN_FULL_TABLE);
+  if (idx_len == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *data_free= new(std::nothrow) ColumnInfo("DATA_FREE",
+                                                           MY_INT64_NUM_DECIMAL_DIGITS,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                           "Data_free",
+                                                           OPEN_FULL_TABLE);
+  if (data_free == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *auto_inc= new(std::nothrow) ColumnInfo("AUTO_INCREMENT",
+                                                           MY_INT64_NUM_DECIMAL_DIGITS,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                           "Auto_increment",
+                                                           OPEN_FULL_TABLE);
+  if (auto_inc == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *create_time= new(std::nothrow) ColumnInfo("CREATE_TIME",
+                                                              0,
+                                                              DRIZZLE_TYPE_DATETIME,
+                                                              0,
+                                                              1,
+                                                              "Create_time",
+                                                              OPEN_FULL_TABLE);
+  if (create_time == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *update_time= new(std::nothrow) ColumnInfo("UPDATE_TIME",
+                                                              0,
+                                                              DRIZZLE_TYPE_DATETIME,
+                                                              0,
+                                                              1,
+                                                              "Update_time",
+                                                              OPEN_FULL_TABLE);
+  if (update_time == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *check_time= new(std::nothrow) ColumnInfo("CHECK_TIME",
+                                                             0,
+                                                             DRIZZLE_TYPE_DATETIME,
+                                                             0,
+                                                             1,
+                                                             "Check_time",
+                                                             OPEN_FULL_TABLE);
+  if (check_time == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *table_coll= new(std::nothrow) ColumnInfo("TABLE_COLLATION",
+                                                             64,
+                                                             DRIZZLE_TYPE_VARCHAR,
+                                                             0,
+                                                             1,
+                                                             "Collation",
+                                                             OPEN_FRM_ONLY);
+  if (table_coll == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *checksum= new(std::nothrow) ColumnInfo("CHECKSUM",
+                                                           MY_INT64_NUM_DECIMAL_DIGITS,
+                                                           DRIZZLE_TYPE_LONGLONG,
+                                                           0,
+                                                           (MY_I_S_MAYBE_NULL | MY_I_S_UNSIGNED),
+                                                           "Checksum",
+                                                           OPEN_FULL_TABLE);
+  if (checksum == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *create_opt= new(std::nothrow) ColumnInfo("CREATE_OPTIONS",
+                                                             255,
+                                                             DRIZZLE_TYPE_VARCHAR,
+                                                             0,
+                                                             1,
+                                                             "Create_options",
+                                                             OPEN_FRM_ONLY);
+  if (create_opt == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_comment= new(std::nothrow) ColumnInfo("TABLE_COMMENT",
+                                                              TABLE_COMMENT_MAXLEN,
+                                                              DRIZZLE_TYPE_VARCHAR,
+                                                              0,
+                                                              0,
+                                                              "Comment",
+                                                              OPEN_FRM_ONLY);
+  if (tab_comment == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(cat);
+  cols.push_back(sch);
+  cols.push_back(name);
+  cols.push_back(type);
+  cols.push_back(engine);
+  cols.push_back(version);
+  cols.push_back(row_format);
+  cols.push_back(tab_rows);
+  cols.push_back(avg_row_len);
+  cols.push_back(data_len);
+  cols.push_back(max_data_len);
+  cols.push_back(idx_len);
+  cols.push_back(data_free);
+  cols.push_back(auto_inc);
+  cols.push_back(create_time);
+  cols.push_back(update_time);
+  cols.push_back(check_time);
+  cols.push_back(table_coll);
+  cols.push_back(checksum);
+  cols.push_back(create_opt);
+  cols.push_back(tab_comment);
+
+  return false;
+}
+
+
+bool createTabNamesColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *cat= new(std::nothrow) ColumnInfo("TABLE_CATALOG",
+                                                      FN_REFLEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      SKIP_OPEN_TABLE);
+  if (cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch= new(std::nothrow) ColumnInfo("TABLE_SCHEMA",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      SKIP_OPEN_TABLE);
+  if (sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Tables_in_",
+                                                       SKIP_OPEN_TABLE);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *type= new(std::nothrow) ColumnInfo("TABLE_TYPE",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Table_type",
+                                                       OPEN_FRM_ONLY);
+  if (type == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(cat);
+  cols.push_back(sch);
+  cols.push_back(name);
+  cols.push_back(type);
+
+  return false;
+}
+
 /*
  * Function object used for deleting the memory allocated
  * for the columns contained with the vector of columns.

=== modified file 'plugin/info_schema/info_schema_columns.h'
--- plugin/info_schema/info_schema_columns.h	2009-06-29 16:05:47 +0000
+++ plugin/info_schema/info_schema_columns.h	2009-07-01 03:36:14 +0000
@@ -23,6 +23,8 @@
 
 #include "drizzled/info_schema.h"
 
+#include <vector>
+
 /**
  * Create the various columns for the CHARACTER_SET I_S table and add them
  * to the std::vector of columns for the CHARACTER_SET table.
@@ -52,6 +54,16 @@
 bool createCollCharSetColumns(std::vector<const ColumnInfo *>& cols);
 
 /**
+ * Create the various columns for the COLUMNS
+ * I_S table and add them to the std::vector of columns for the
+ * table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createColColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Create the various columns for the key column usage
  * I_S table and add them to the std::vector of columns for the
  * table.
@@ -62,6 +74,16 @@
 bool createKeyColUsageColumns(std::vector<const ColumnInfo *>& cols);
 
 /**
+ * Create the various columns for the OPEN_TABLES
+ * I_S table and add them to the std::vector of columns for the
+ * table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createOpenTabColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Create the various columns for the PLUGINS
  * I_S table and add them to the std::vector of columns for the
  * table.
@@ -90,6 +112,24 @@
 bool createRefConstraintColumns(std::vector<const ColumnInfo *>& cols);
 
 /**
+ * Create the various volumns for the SCHEMATA I_S table 
+ * and add them to the std::vector of columns for this table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createSchemataColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
+ * Create the various volumns for the STATISTICS I_S table 
+ * and add them to the std::vector of columns for this table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createStatsColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Create the various volumns for the TABLE_CONSTRAINTS I_S table 
  * and add them to the std::vector of columns for this table.
  *
@@ -99,6 +139,24 @@
 bool createTabConstraintsColumns(std::vector<const ColumnInfo *>& cols);
 
 /**
+ * Create the various volumns for the TABLE_NAMES I_S table 
+ * and add them to the std::vector of columns for this table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createTablesColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
+ * Create the various volumns for the TABLE_NAMES I_S table 
+ * and add them to the std::vector of columns for this table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createTabNamesColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Iterate through the given vector of columns and delete the memory that
  * has been allocated for them.
  *

=== modified file 'plugin/info_schema/info_schema_methods.cc'
--- plugin/info_schema/info_schema_methods.cc	2009-06-29 16:05:47 +0000
+++ plugin/info_schema/info_schema_methods.cc	2009-07-01 03:36:14 +0000
@@ -26,9 +26,14 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/session.h>
 #include <drizzled/show.h>
+#include <drizzled/tztime.h>
+#include <drizzled/sql_base.h>
 
 #include "info_schema_methods.h"
 
+#include <vector>
+#include <string>
+
 using namespace std;
 
 int CharSetISMethods::fillTable(Session *session, TableList *tables, COND *)
@@ -97,17 +102,17 @@
   {
     CHARSET_INFO **cl;
     const CHARSET_INFO *tmp_cs= cs[0];
-    if (!tmp_cs || !(tmp_cs->state & MY_CS_AVAILABLE) ||
+    if (! tmp_cs || ! (tmp_cs->state & MY_CS_AVAILABLE) ||
          (tmp_cs->state & MY_CS_HIDDEN) ||
         !(tmp_cs->state & MY_CS_PRIMARY))
       continue;
     for (cl= all_charsets; cl < all_charsets+255 ;cl ++)
     {
       const CHARSET_INFO *tmp_cl= cl[0];
-      if (!tmp_cl || !(tmp_cl->state & MY_CS_AVAILABLE) ||
+      if (! tmp_cl || ! (tmp_cl->state & MY_CS_AVAILABLE) ||
           !my_charset_same(tmp_cs, tmp_cl))
         continue;
-      if (!(wild && wild[0] &&
+      if (! (wild && wild[0] &&
           wild_case_compare(scs, tmp_cl->name,wild)))
       {
         const char *tmp_buff;
@@ -137,14 +142,14 @@
   {
     CHARSET_INFO **cl;
     const CHARSET_INFO *tmp_cs= cs[0];
-    if (!tmp_cs || !(tmp_cs->state & MY_CS_AVAILABLE) ||
-        !(tmp_cs->state & MY_CS_PRIMARY))
+    if (! tmp_cs || ! (tmp_cs->state & MY_CS_AVAILABLE) ||
+        ! (tmp_cs->state & MY_CS_PRIMARY))
       continue;
     for (cl= all_charsets; cl < all_charsets+255 ;cl ++)
     {
       const CHARSET_INFO *tmp_cl= cl[0];
-      if (!tmp_cl || !(tmp_cl->state & MY_CS_AVAILABLE) ||
-          !my_charset_same(tmp_cs,tmp_cl))
+      if (! tmp_cl || ! (tmp_cl->state & MY_CS_AVAILABLE) ||
+          ! my_charset_same(tmp_cs,tmp_cl))
         continue;
       table->restoreRecordAsDefault();
       table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
@@ -156,6 +161,40 @@
   return 0;
 }
 
+int ColumnsISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
+  const
+{
+  int fields_arr[]= {3, 14, 13, 6, 15, 5, 16, 17, 18, -1};
+  int *field_num= fields_arr;
+  const InfoSchemaTable::Columns columns= schema_table->getColumns();
+  const ColumnInfo *column;
+  Name_resolution_context *context= &session->lex->select_lex.context;
+
+  for (; *field_num >= 0; field_num++)
+  {
+    column= columns[*field_num];
+    if (! session->lex->verbose && (*field_num == 13 ||
+                                    *field_num == 17 ||
+                                    *field_num == 18))
+    {
+      continue;
+    }
+    Item_field *field= new Item_field(context,
+                                      NULL, NULL, column->getName().c_str());
+    if (field)
+    {
+      field->set_name(column->getOldName().c_str(),
+                      column->getOldName().length(),
+                      system_charset_info);
+      if (session->add_item_to_list(field))
+      {
+        return 1;
+      }
+    }
+  }
+  return 0;
+}
+
 static void store_key_column_usage(Table *table, LEX_STRING *db_name,
                                    LEX_STRING *table_name, const char *key_name,
                                    uint32_t key_len, const char *con_type, uint32_t con_len,
@@ -264,6 +303,33 @@
   return (res);
 }
 
+int OpenTablesISMethods::fillTable(Session *session, TableList *tables, COND *)
+{
+  const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
+  Table *table= tables->table;
+  const CHARSET_INFO * const cs= system_charset_info;
+  OPEN_TableList *open_list;
+  if (! (open_list= list_open_tables(session->lex->select_lex.db, wild)) &&
+      session->is_fatal_error)
+  {
+    return (1);
+  }
+
+  for (; open_list ; open_list=open_list->next)
+  {
+    table->restoreRecordAsDefault();
+    table->field[0]->store(open_list->db, strlen(open_list->db), cs);
+    table->field[1]->store(open_list->table, strlen(open_list->table), cs);
+    table->field[2]->store((int64_t) open_list->in_use, true);
+    table->field[3]->store((int64_t) open_list->locked, true);
+    if (schema_table_store_record(session, table))
+    {
+      return (1);
+    }
+  }
+  return (0);
+}
+
 class ShowPlugins : public unary_function<st_plugin_int *, bool>
 {
   Session *session;
@@ -370,7 +436,7 @@
 
   pthread_mutex_lock(&LOCK_thread_count);
 
-  if (!session->killed)
+  if (! session->killed)
   {
     Session* tmp;
 
@@ -511,6 +577,214 @@
   return (0);
 }
 
+static bool store_schema_schemata(Session* session, Table *table, LEX_STRING *db_name,
+                                  const CHARSET_INFO * const cs)
+{
+  table->restoreRecordAsDefault();
+  table->field[1]->store(db_name->str, db_name->length, system_charset_info);
+  table->field[2]->store(cs->csname, strlen(cs->csname), system_charset_info);
+  table->field[3]->store(cs->name, strlen(cs->name), system_charset_info);
+  return schema_table_store_record(session, table);
+}
+
+int SchemataISMethods::fillTable(Session *session, TableList *tables, COND *cond)
+{
+  /*
+    TODO: fill_schema_shemata() is called when new client is connected.
+    Returning error status in this case leads to client hangup.
+  */
+
+  LOOKUP_FIELD_VALUES lookup_field_vals;
+  List<LEX_STRING> db_names;
+  LEX_STRING *db_name;
+  bool with_i_schema;
+  Table *table= tables->table;
+
+  if (get_lookup_field_values(session, cond, tables, &lookup_field_vals))
+    return(0);
+  if (make_db_list(session, &db_names, &lookup_field_vals,
+                   &with_i_schema))
+    return(1);
+
+  /*
+    If we have lookup db value we should check that the database exists
+  */
+  if(lookup_field_vals.db_value.str && !lookup_field_vals.wild_db_value &&
+     !with_i_schema)
+  {
+    char path[FN_REFLEN+16];
+    uint32_t path_len;
+    struct stat stat_info;
+    if (!lookup_field_vals.db_value.str[0])
+      return(0);
+    path_len= build_table_filename(path, sizeof(path),
+                                   lookup_field_vals.db_value.str, "", false);
+    path[path_len-1]= 0;
+    if (stat(path,&stat_info))
+      return(0);
+  }
+
+  List_iterator_fast<LEX_STRING> it(db_names);
+  while ((db_name=it++))
+  {
+    if (with_i_schema)       // information schema name is always first in list
+    {
+      if (store_schema_schemata(session, table, db_name,
+                               system_charset_info))
+        return(1);
+      with_i_schema= 0;
+      continue;
+    }
+    {
+      HA_CREATE_INFO create;
+      load_db_opt_by_name(db_name->str, &create);
+
+      if (store_schema_schemata(session, table, db_name,
+                               create.default_table_charset))
+        return(1);
+    }
+  }
+  return(0);
+}
+
+int SchemataISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
+  const
+{
+  char tmp[128];
+  LEX *lex= session->lex;
+  Select_Lex *sel= lex->current_select;
+  Name_resolution_context *context= &sel->context;
+  const InfoSchemaTable::Columns columns= schema_table->getColumns();
+
+  if (!sel->item_list.elements)
+  {
+    const ColumnInfo *column= columns[1];
+    String buffer(tmp,sizeof(tmp), system_charset_info);
+    Item_field *field= new Item_field(context,
+                                      NULL, NULL, column->getName().c_str());
+    if (!field || session->add_item_to_list(field))
+      return 1;
+    buffer.length(0);
+    buffer.append(column->getOldName().c_str());
+    if (lex->wild && lex->wild->ptr())
+    {
+      buffer.append(STRING_WITH_LEN(" ("));
+      buffer.append(lex->wild->ptr());
+      buffer.append(')');
+    }
+    field->set_name(buffer.ptr(), buffer.length(), system_charset_info);
+  }
+  return 0;
+}
+
+int StatsISMethods::processTable(Session *session, TableList *tables,
+                                  Table *table, bool res,
+                                  LEX_STRING *db_name,
+                                  LEX_STRING *table_name) const
+{
+  const CHARSET_INFO * const cs= system_charset_info;
+  if (res)
+  {
+    if (session->lex->sql_command != SQLCOM_SHOW_KEYS)
+    {
+      /*
+        I.e. we are in SELECT FROM INFORMATION_SCHEMA.STATISTICS
+        rather than in SHOW KEYS
+      */
+      if (session->is_error())
+      {
+        push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+                     session->main_da.sql_errno(), session->main_da.message());
+      }
+      session->clear_error();
+      res= 0;
+    }
+    return (res);
+  }
+  else
+  {
+    Table *show_table= tables->table;
+    KEY *key_info=show_table->s->key_info;
+    if (show_table->file)
+    {
+      show_table->file->info(HA_STATUS_VARIABLE |
+                             HA_STATUS_NO_LOCK |
+                             HA_STATUS_TIME);
+    }
+    for (uint32_t i=0 ; i < show_table->s->keys ; i++,key_info++)
+    {
+      KEY_PART_INFO *key_part= key_info->key_part;
+      const char *str;
+      for (uint32_t j=0 ; j < key_info->key_parts ; j++,key_part++)
+      {
+        table->restoreRecordAsDefault();
+        table->field[1]->store(db_name->str, db_name->length, cs);
+        table->field[2]->store(table_name->str, table_name->length, cs);
+        table->field[3]->store((int64_t) ((key_info->flags &
+                                            HA_NOSAME) ? 0 : 1), true);
+        table->field[4]->store(db_name->str, db_name->length, cs);
+        table->field[5]->store(key_info->name, strlen(key_info->name), cs);
+        table->field[6]->store((int64_t) (j+1), true);
+        str=(key_part->field ? key_part->field->field_name :
+             "?unknown field?");
+        table->field[7]->store(str, strlen(str), cs);
+        if (show_table->file)
+        {
+          if (show_table->file->index_flags(i, j, 0) & HA_READ_ORDER)
+          {
+            table->field[8]->store(((key_part->key_part_flag &
+                                     HA_REVERSE_SORT) ?
+                                    "D" : "A"), 1, cs);
+            table->field[8]->set_notnull();
+          }
+          KEY *key=show_table->key_info+i;
+          if (key->rec_per_key[j])
+          {
+            ha_rows records=(show_table->file->stats.records /
+                             key->rec_per_key[j]);
+            table->field[9]->store((int64_t) records, true);
+            table->field[9]->set_notnull();
+          }
+          str= show_table->file->index_type(i);
+          table->field[13]->store(str, strlen(str), cs);
+        }
+        if ((key_part->field &&
+             key_part->length !=
+             show_table->s->field[key_part->fieldnr-1]->key_length()))
+        {
+          table->field[10]->store((int64_t) key_part->length /
+                                  key_part->field->charset()->mbmaxlen, true);
+          table->field[10]->set_notnull();
+        }
+        uint32_t flags= key_part->field ? key_part->field->flags : 0;
+        const char *pos=(char*) ((flags & NOT_NULL_FLAG) ? "" : "YES");
+        table->field[12]->store(pos, strlen(pos), cs);
+        if (!show_table->s->keys_in_use.test(i))
+        {
+          table->field[14]->store(STRING_WITH_LEN("disabled"), cs);
+        }
+        else
+        {
+          table->field[14]->store("", 0, cs);
+        }
+        table->field[14]->set_notnull();
+        assert(test(key_info->flags & HA_USES_COMMENT) ==
+                   (key_info->comment.length > 0));
+        if (key_info->flags & HA_USES_COMMENT)
+        {
+          table->field[15]->store(key_info->comment.str,
+                                  key_info->comment.length, cs);
+        }
+        if (schema_table_store_record(session, table))
+        {
+          return (1);
+        }
+      }
+    }
+  }
+  return(res);
+}
+
 static bool store_constraints(Session *session, Table *table, LEX_STRING *db_name,
                               LEX_STRING *table_name, const char *key_name,
                               uint32_t key_len, const char *con_type, uint32_t con_len)
@@ -592,3 +866,254 @@
   }
   return (res);
 }
+
+
+/* Match the values of enum ha_choice */
+static const char *ha_choice_values[] = {"", "0", "1"};
+
+int TablesISMethods::processTable(Session *session, TableList *tables,
+                                    Table *table, bool res,
+                                    LEX_STRING *db_name,
+                                    LEX_STRING *table_name) const
+{
+  const char *tmp_buff;
+  DRIZZLE_TIME time;
+  const CHARSET_INFO * const cs= system_charset_info;
+
+  table->restoreRecordAsDefault();
+  table->field[1]->store(db_name->str, db_name->length, cs);
+  table->field[2]->store(table_name->str, table_name->length, cs);
+  if (res)
+  {
+    /*
+      there was errors during opening tables
+    */
+    const char *error= session->is_error() ? session->main_da.message() : "";
+    if (tables->schema_table)
+    {
+      table->field[3]->store(STRING_WITH_LEN("SYSTEM VIEW"), cs);
+    }
+    else
+    {
+      table->field[3]->store(STRING_WITH_LEN("BASE Table"), cs);
+    }
+    table->field[20]->store(error, strlen(error), cs);
+    session->clear_error();
+  }
+  else
+  {
+    char option_buff[400],*ptr;
+    Table *show_table= tables->table;
+    TableShare *share= show_table->s;
+    handler *file= show_table->file;
+    StorageEngine *tmp_db_type= share->db_type();
+    if (share->tmp_table == SYSTEM_TMP_TABLE)
+    {
+      table->field[3]->store(STRING_WITH_LEN("SYSTEM VIEW"), cs);
+    }
+    else if (share->tmp_table)
+    {
+      table->field[3]->store(STRING_WITH_LEN("LOCAL TEMPORARY"), cs);
+    }
+    else
+    {
+      table->field[3]->store(STRING_WITH_LEN("BASE Table"), cs);
+    }
+
+    for (int i= 4; i < 20; i++)
+    {
+      if (i == 7 || (i > 12 && i < 17) || i == 18)
+      {
+        continue;
+      }
+      table->field[i]->set_notnull();
+    }
+    string engine_name= ha_resolve_storage_engine_name(tmp_db_type);
+    table->field[4]->store(engine_name.c_str(), engine_name.size(), cs);
+    table->field[5]->store((int64_t) 0, true);
+
+    ptr=option_buff;
+    if (share->min_rows)
+    {
+      ptr= strcpy(ptr," min_rows=")+10;
+      ptr= int64_t10_to_str(share->min_rows,ptr,10);
+    }
+    if (share->max_rows)
+    {
+      ptr= strcpy(ptr," max_rows=")+10;
+      ptr= int64_t10_to_str(share->max_rows,ptr,10);
+    }
+    if (share->avg_row_length)
+    {
+      ptr= strcpy(ptr," avg_row_length=")+16;
+      ptr= int64_t10_to_str(share->avg_row_length,ptr,10);
+    }
+    if (share->db_create_options & HA_OPTION_PACK_KEYS)
+    {
+      ptr= strcpy(ptr," pack_keys=1")+12;
+    }
+    if (share->db_create_options & HA_OPTION_NO_PACK_KEYS)
+    {
+      ptr= strcpy(ptr," pack_keys=0")+12;
+    }
+    /* We use CHECKSUM, instead of TABLE_CHECKSUM, for backward compability */
+    if (share->db_create_options & HA_OPTION_CHECKSUM)
+    {
+      ptr= strcpy(ptr," checksum=1")+11;
+    }
+    if (share->page_checksum != HA_CHOICE_UNDEF)
+    {
+      ptr+= sprintf(ptr, " page_checksum=%s",
+                    ha_choice_values[(uint32_t) share->page_checksum]);
+    }
+    if (share->db_create_options & HA_OPTION_DELAY_KEY_WRITE)
+    {
+      ptr= strcpy(ptr," delay_key_write=1")+18;
+    }
+    if (share->row_type != ROW_TYPE_DEFAULT)
+    {
+      ptr+= sprintf(ptr, " row_format=%s", ha_row_type[(uint32_t)share->row_type]);
+    }
+    if (share->block_size)
+    {
+      ptr= strcpy(ptr, " block_size=")+12;
+      ptr= int64_t10_to_str(share->block_size, ptr, 10);
+    }
+
+    table->field[19]->store(option_buff+1,
+                            (ptr == option_buff ? 0 :
+                             (uint32_t) (ptr-option_buff)-1), cs);
+
+    tmp_buff= (share->table_charset ?
+               share->table_charset->name : "default");
+    table->field[17]->store(tmp_buff, strlen(tmp_buff), cs);
+
+    if (share->comment.str)
+      table->field[20]->store(share->comment.str, share->comment.length, cs);
+
+    if(file)
+    {
+      file->info(HA_STATUS_VARIABLE | HA_STATUS_TIME | HA_STATUS_AUTO |
+                 HA_STATUS_NO_LOCK);
+      enum row_type row_type = file->get_row_type();
+      switch (row_type) {
+      case ROW_TYPE_NOT_USED:
+      case ROW_TYPE_DEFAULT:
+        tmp_buff= ((share->db_options_in_use &
+                    HA_OPTION_COMPRESS_RECORD) ? "Compressed" :
+                   (share->db_options_in_use & HA_OPTION_PACK_RECORD) ?
+                   "Dynamic" : "Fixed");
+        break;
+      case ROW_TYPE_FIXED:
+        tmp_buff= "Fixed";
+        break;
+      case ROW_TYPE_DYNAMIC:
+        tmp_buff= "Dynamic";
+        break;
+      case ROW_TYPE_COMPRESSED:
+        tmp_buff= "Compressed";
+        break;
+      case ROW_TYPE_REDUNDANT:
+        tmp_buff= "Redundant";
+        break;
+      case ROW_TYPE_COMPACT:
+        tmp_buff= "Compact";
+        break;
+      case ROW_TYPE_PAGE:
+        tmp_buff= "Paged";
+        break;
+      }
+      table->field[6]->store(tmp_buff, strlen(tmp_buff), cs);
+      if (! tables->schema_table)
+      {
+        table->field[7]->store((int64_t) file->stats.records, true);
+        table->field[7]->set_notnull();
+      }
+      table->field[8]->store((int64_t) file->stats.mean_rec_length, true);
+      table->field[9]->store((int64_t) file->stats.data_file_length, true);
+      if (file->stats.max_data_file_length)
+      {
+        table->field[10]->store((int64_t) file->stats.max_data_file_length,
+                                true);
+      }
+      table->field[11]->store((int64_t) file->stats.index_file_length, true);
+      table->field[12]->store((int64_t) file->stats.delete_length, true);
+      if (show_table->found_next_number_field)
+      {
+        table->field[13]->store((int64_t) file->stats.auto_increment_value,
+                                true);
+        table->field[13]->set_notnull();
+      }
+      if (file->stats.create_time)
+      {
+        session->variables.time_zone->gmt_sec_to_TIME(&time,
+                                                  (time_t) file->stats.create_time);
+        table->field[14]->store_time(&time, DRIZZLE_TIMESTAMP_DATETIME);
+        table->field[14]->set_notnull();
+      }
+      if (file->stats.update_time)
+      {
+        session->variables.time_zone->gmt_sec_to_TIME(&time,
+                                                  (time_t) file->stats.update_time);
+        table->field[15]->store_time(&time, DRIZZLE_TIMESTAMP_DATETIME);
+        table->field[15]->set_notnull();
+      }
+      if (file->stats.check_time)
+      {
+        session->variables.time_zone->gmt_sec_to_TIME(&time,
+                                                  (time_t) file->stats.check_time);
+        table->field[16]->store_time(&time, DRIZZLE_TIMESTAMP_DATETIME);
+        table->field[16]->set_notnull();
+      }
+      if (file->ha_table_flags() & (ulong) HA_HAS_CHECKSUM)
+      {
+        table->field[18]->store((int64_t) file->checksum(), true);
+        table->field[18]->set_notnull();
+      }
+    }
+  }
+  return (schema_table_store_record(session, table));
+}
+
+
+int TabNamesISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
+  const
+{
+  char tmp[128];
+  String buffer(tmp,sizeof(tmp), session->charset());
+  LEX *lex= session->lex;
+  Name_resolution_context *context= &lex->select_lex.context;
+  const InfoSchemaTable::Columns columns= schema_table->getColumns();
+
+  const ColumnInfo *column= columns[2];
+  buffer.length(0);
+  buffer.append(column->getOldName().c_str());
+  buffer.append(lex->select_lex.db);
+  if (lex->wild && lex->wild->ptr())
+  {
+    buffer.append(STRING_WITH_LEN(" ("));
+    buffer.append(lex->wild->ptr());
+    buffer.append(')');
+  }
+  Item_field *field= new Item_field(context,
+                                    NULL, NULL, column->getName().c_str());
+  if (session->add_item_to_list(field))
+  {
+    return 1;
+  }
+  field->set_name(buffer.ptr(), buffer.length(), system_charset_info);
+  if (session->lex->verbose)
+  {
+    field->set_name(buffer.ptr(), buffer.length(), system_charset_info);
+    column= columns[3];
+    field= new Item_field(context, NULL, NULL, column->getName().c_str());
+    if (session->add_item_to_list(field))
+    {
+      return 1;
+    }
+    field->set_name(column->getOldName().c_str(),
+                    column->getOldName().length(),
+                    system_charset_info);
+  }
+  return 0;
+}

=== modified file 'plugin/info_schema/info_schema_methods.h'
--- plugin/info_schema/info_schema_methods.h	2009-06-29 16:05:47 +0000
+++ plugin/info_schema/info_schema_methods.h	2009-07-01 03:36:14 +0000
@@ -24,8 +24,7 @@
 #include "drizzled/info_schema.h"
 
 /**
- * @class
- *   CharSetISMethods
+ * @class CharSetISMethods
  * @brief
  *   Class which implements any methods that the 
  *   CHARACTER_SET I_S table needs besides the default
@@ -41,8 +40,7 @@
 };
 
 /**
- * @class
- *   CollationISMethods
+ * @class CollationISMethods
  * @brief
  *   Class which implements any methods that the Collations
  *   I_S table needs besides the default methods
@@ -56,8 +54,7 @@
 };
 
 /**
- * @class
- *   CollCharISMethods
+ * @class CollCharISMethods
  * @brief
  *   Class which implements any methods that the collation char set
  *   I_S table needs besides the default methods
@@ -71,8 +68,19 @@
 };
 
 /**
- * @class
- *   KeyColUsageISMethods
+ * @class ColumnsISMethods
+ * @brief
+ *   Class which implements any methods that the COLUMNS
+ *   I_S table needs besides the default methods
+ */
+class ColumnsISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
+};
+
+/**
+ * @class KeyColUsageISMethods
  * @brief
  *   Class which implements any methods that the key column usage
  *   I_S table needs besides the default methods
@@ -86,8 +94,21 @@
 };
 
 /**
- * @class
- *   PluginsISMethods
+ * @class OpenTablesISMethods
+ * @brief
+ *   Class which implements any methods that the OPEN_TABLES
+ *   I_S table needs besides the default methods
+ */
+class OpenTablesISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int fillTable(Session *session,
+                        TableList *tables,
+                        COND *cond);
+};
+
+/**
+ * @class PluginsISMethods
  * @brief
  *   Class which implements any methods that the PLUGINS
  *   I_S table needs besides the default methods
@@ -101,8 +122,7 @@
 };
 
 /**
- * @class
- *   ProcessListISMethods
+ * @class ProcessListISMethods
  * @brief
  *   Class which implements any methods that the PROCESSLIST
  *   I_S table needs besides the default methods
@@ -116,8 +136,7 @@
 };
 
 /**
- * @class
- *   RefConstraintISMethods
+ * @class RefConstraintISMethods
  * @brief
  *   Class which implements any methods that the REFERENTIAL_CONSTRAINTS
  *   I_S table needs besides the default methods
@@ -144,8 +163,36 @@
 };
 
 /**
- * @class
- *   TabConstraintsISMethods
+ * @class SchemataISMethods
+ * @brief
+ *   Class which implements any methods that the SCHEMATA
+ *   I_S table needs besides the default methods
+ */
+class SchemataISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int fillTable(Session *session,
+                        TableList *tables,
+                        COND *cond);
+  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
+};
+
+/**
+ * @class StatsISMethods
+ * @brief
+ *   Class which implements any methods that the SCHEMATA
+ *   I_S table needs besides the default methods
+ */
+class StatsISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int processTable(Session *session, TableList *tables,
+                           Table *table, bool res, LEX_STRING *db_name,
+                           LEX_STRING *table_name) const;
+};
+
+/**
+ * @class TabConstraintsISMethods
  * @brief
  *   Class which implements any methods that the TABLE_CONSTRAINTS
  *   I_S table needs besides the default methods
@@ -158,4 +205,30 @@
                            LEX_STRING *table_name) const;
 };
 
+/**
+ * @class TablesISMethods
+ * @brief
+ *   Class which implements any methods that the TABLE_NAMES
+ *   I_S table needs besides the default methods
+ */
+class TablesISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int processTable(Session *session, TableList *tables,
+                           Table *table, bool res, LEX_STRING *db_name,
+                           LEX_STRING *table_name) const;
+};
+
+/**
+ * @class TabNamesISMethods
+ * @brief
+ *   Class which implements any methods that the TABLE_NAMES
+ *   I_S table needs besides the default methods
+ */
+class TabNamesISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
+};
+
 #endif /* DRIZZLE_INFO_SCHEMA_METHODS_H */

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2009-06-29 16:07:20 +0000
+++ tests/r/information_schema.result	2009-07-01 03:38:19 +0000
@@ -85,11 +85,11 @@
 select table_name, column_name, data_type from information_schema.columns
 where data_type = 'datetime';
 table_name	column_name	data_type
+INNODB_TRX	trx_started	datetime
+INNODB_TRX	trx_wait_started	datetime
 TABLES	CREATE_TIME	datetime
 TABLES	UPDATE_TIME	datetime
 TABLES	CHECK_TIME	datetime
-INNODB_TRX	trx_started	datetime
-INNODB_TRX	trx_wait_started	datetime
 SELECT COUNT(*) FROM INFORMATION_SCHEMA.TABLES A
 WHERE NOT EXISTS 
 (SELECT * FROM INFORMATION_SCHEMA.COLUMNS B
@@ -244,14 +244,10 @@
         )
 AND t.table_name NOT LIKE 'falcon%';
 table_name	column_name
-COLUMNS	TABLE_SCHEMA
 GLOBAL_STATUS	VARIABLE_NAME
 GLOBAL_VARIABLES	VARIABLE_NAME
-SCHEMATA	SCHEMA_NAME
 SESSION_STATUS	VARIABLE_NAME
 SESSION_VARIABLES	VARIABLE_NAME
-STATISTICS	TABLE_SCHEMA
-TABLES	TABLE_SCHEMA
 INNODB_TRX	trx_id
 INNODB_LOCKS	lock_id
 INNODB_LOCK_WAITS	requesting_trx_id
@@ -262,11 +258,15 @@
 CHARACTER_SETS	CHARACTER_SET_NAME
 COLLATIONS	COLLATION_NAME
 COLLATION_CHARACTER_SET_APPLICABILITY	COLLATION_NAME
+COLUMNS	TABLE_SCHEMA
 KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
 PLUGINS	PLUGIN_NAME
 PROCESSLIST	ID
 REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
+SCHEMATA	SCHEMA_NAME
+STATISTICS	TABLE_SCHEMA
 TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
+TABLES	TABLE_SCHEMA
 SELECT t.table_name, c1.column_name
 FROM information_schema.tables t
 INNER JOIN
@@ -283,14 +283,10 @@
         )
 AND t.table_name NOT LIKE 'falcon%';
 table_name	column_name
-COLUMNS	TABLE_SCHEMA
 GLOBAL_STATUS	VARIABLE_NAME
 GLOBAL_VARIABLES	VARIABLE_NAME
-SCHEMATA	SCHEMA_NAME
 SESSION_STATUS	VARIABLE_NAME
 SESSION_VARIABLES	VARIABLE_NAME
-STATISTICS	TABLE_SCHEMA
-TABLES	TABLE_SCHEMA
 INNODB_TRX	trx_id
 INNODB_LOCKS	lock_id
 INNODB_LOCK_WAITS	requesting_trx_id
@@ -301,11 +297,15 @@
 CHARACTER_SETS	CHARACTER_SET_NAME
 COLLATIONS	COLLATION_NAME
 COLLATION_CHARACTER_SET_APPLICABILITY	COLLATION_NAME
+COLUMNS	TABLE_SCHEMA
 KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
 PLUGINS	PLUGIN_NAME
 PROCESSLIST	ID
 REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
+SCHEMATA	SCHEMA_NAME
+STATISTICS	TABLE_SCHEMA
 TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
+TABLES	TABLE_SCHEMA
 SELECT MAX(table_name) FROM information_schema.tables;
 MAX(table_name)
 TABLE_CONSTRAINTS
@@ -521,12 +521,218 @@
 utf8_hungarian_ci	utf8
 utf8_sinhala_ci	utf8
 binary	binary
+SELECT table_name, column_name
+FROM information_schema.columns;
+table_name	column_name
+GLOBAL_STATUS	VARIABLE_NAME
+GLOBAL_STATUS	VARIABLE_VALUE
+GLOBAL_VARIABLES	VARIABLE_NAME
+GLOBAL_VARIABLES	VARIABLE_VALUE
+SESSION_STATUS	VARIABLE_NAME
+SESSION_STATUS	VARIABLE_VALUE
+SESSION_VARIABLES	VARIABLE_NAME
+SESSION_VARIABLES	VARIABLE_VALUE
+INNODB_TRX	trx_id
+INNODB_TRX	trx_state
+INNODB_TRX	trx_started
+INNODB_TRX	trx_requested_lock_id
+INNODB_TRX	trx_wait_started
+INNODB_TRX	trx_weight
+INNODB_TRX	trx_mysql_thread_id
+INNODB_TRX	trx_query
+INNODB_LOCKS	lock_id
+INNODB_LOCKS	lock_trx_id
+INNODB_LOCKS	lock_mode
+INNODB_LOCKS	lock_type
+INNODB_LOCKS	lock_table
+INNODB_LOCKS	lock_index
+INNODB_LOCKS	lock_space
+INNODB_LOCKS	lock_page
+INNODB_LOCKS	lock_rec
+INNODB_LOCKS	lock_data
+INNODB_LOCK_WAITS	requesting_trx_id
+INNODB_LOCK_WAITS	requested_lock_id
+INNODB_LOCK_WAITS	blocking_trx_id
+INNODB_LOCK_WAITS	blocking_lock_id
+INNODB_CMP	page_size
+INNODB_CMP	compress_ops
+INNODB_CMP	compress_ops_ok
+INNODB_CMP	compress_time
+INNODB_CMP	uncompress_ops
+INNODB_CMP	uncompress_time
+INNODB_CMP_RESET	page_size
+INNODB_CMP_RESET	compress_ops
+INNODB_CMP_RESET	compress_ops_ok
+INNODB_CMP_RESET	compress_time
+INNODB_CMP_RESET	uncompress_ops
+INNODB_CMP_RESET	uncompress_time
+INNODB_CMPMEM	page_size
+INNODB_CMPMEM	pages_used
+INNODB_CMPMEM	pages_free
+INNODB_CMPMEM	relocation_ops
+INNODB_CMPMEM	relocation_time
+INNODB_CMPMEM_RESET	page_size
+INNODB_CMPMEM_RESET	pages_used
+INNODB_CMPMEM_RESET	pages_free
+INNODB_CMPMEM_RESET	relocation_ops
+INNODB_CMPMEM_RESET	relocation_time
+CHARACTER_SETS	CHARACTER_SET_NAME
+CHARACTER_SETS	DEFAULT_COLLATE_NAME
+CHARACTER_SETS	DESCRIPTION
+CHARACTER_SETS	MAXLEN
+COLLATIONS	COLLATION_NAME
+COLLATIONS	CHARACTER_SET_NAME
+COLLATIONS	DESCRIPTION
+COLLATIONS	ID
+COLLATIONS	IS_DEFAULT
+COLLATIONS	IS_COMPILED
+COLLATIONS	SORTLEN
+COLLATION_CHARACTER_SET_APPLICABILITY	COLLATION_NAME
+COLLATION_CHARACTER_SET_APPLICABILITY	CHARACTER_SET_NAME
+COLUMNS	TABLE_CATALOG
+COLUMNS	TABLE_SCHEMA
+COLUMNS	TABLE_NAME
+COLUMNS	COLUMN_NAME
+COLUMNS	ORDINAL_POSITION
+COLUMNS	COLUMN_DEFAULT
+COLUMNS	IS_NULLABLE
+COLUMNS	DATA_TYPE
+COLUMNS	CHARACTER_MAXIMUM_LENGTH
+COLUMNS	CHARACTER_OCTET_LENGTH
+COLUMNS	NUMERIC_PRECISION
+COLUMNS	NUMERIC_SCALE
+COLUMNS	CHARACTER_SET_NAME
+COLUMNS	COLLATION_NAME
+COLUMNS	COLUMN_TYPE
+COLUMNS	COLUMN_KEY
+COLUMNS	EXTRA
+COLUMNS	PRIVILEGES
+COLUMNS	COLUMN_COMMENT
+COLUMNS	STORAGE
+COLUMNS	FORMAT
+KEY_COLUMN_USAGE	CONSTRAINT_CATALOG
+KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
+KEY_COLUMN_USAGE	CONSTRAINT_NAME
+KEY_COLUMN_USAGE	TABLE_CATALOG
+KEY_COLUMN_USAGE	TABLE_SCHEMA
+KEY_COLUMN_USAGE	TABLE_NAME
+KEY_COLUMN_USAGE	COLUMN_NAME
+KEY_COLUMN_USAGE	ORDINAL_POSITION
+KEY_COLUMN_USAGE	POSITION_IN_UNIQUE_CONSTRAINT
+KEY_COLUMN_USAGE	REFERENCED_TABLE_SCHEMA
+KEY_COLUMN_USAGE	REFERENCED_TABLE_NAME
+KEY_COLUMN_USAGE	REFERENCED_COLUMN_NAME
+PLUGINS	PLUGIN_NAME
+PLUGINS	PLUGIN_VERSION
+PLUGINS	PLUGIN_STATUS
+PLUGINS	PLUGIN_AUTHOR
+PLUGINS	PLUGIN_DESCRIPTION
+PLUGINS	PLUGIN_LICENSE
+PROCESSLIST	ID
+PROCESSLIST	USER
+PROCESSLIST	HOST
+PROCESSLIST	DB
+PROCESSLIST	COMMAND
+PROCESSLIST	TIME
+PROCESSLIST	STATE
+PROCESSLIST	INFO
+REFERENTIAL_CONSTRAINTS	CONSTRAINT_CATALOG
+REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
+REFERENTIAL_CONSTRAINTS	CONSTRAINT_NAME
+REFERENTIAL_CONSTRAINTS	UNIQUE_CONSTRAINT_CATALOG
+REFERENTIAL_CONSTRAINTS	UNIQUE_CONSTRAINT_SCHEMA
+REFERENTIAL_CONSTRAINTS	UNIQUE_CONSTRAINT_NAME
+REFERENTIAL_CONSTRAINTS	MATCH_OPTION
+REFERENTIAL_CONSTRAINTS	UPDATE_RULE
+REFERENTIAL_CONSTRAINTS	DELETE_RULE
+REFERENTIAL_CONSTRAINTS	TABLE_NAME
+REFERENTIAL_CONSTRAINTS	REFERENCED_TABLE_NAME
+SCHEMATA	CATALOG_NAME
+SCHEMATA	SCHEMA_NAME
+SCHEMATA	DEFAULT_CHARACTER_SET_NAME
+SCHEMATA	DEFAULT_COLLATION_NAME
+SCHEMATA	SQL_PATH
+STATISTICS	TABLE_CATALOG
+STATISTICS	TABLE_SCHEMA
+STATISTICS	TABLE_NAME
+STATISTICS	NON_UNIQUE
+STATISTICS	INDEX_SCHEMA
+STATISTICS	INDEX_NAME
+STATISTICS	SEQ_IN_INDEX
+STATISTICS	COLUMN_NAME
+STATISTICS	COLLATION
+STATISTICS	CARDINALITY
+STATISTICS	SUB_PART
+STATISTICS	PACKED
+STATISTICS	NULLABLE
+STATISTICS	INDEX_TYPE
+STATISTICS	COMMENT
+STATISTICS	INDEX_COMMENT
+TABLE_CONSTRAINTS	CONSTRAINT_CATALOG
+TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
+TABLE_CONSTRAINTS	CONSTRAINT_NAME
+TABLE_CONSTRAINTS	TABLE_SCHEMA
+TABLE_CONSTRAINTS	TABLE_NAME
+TABLE_CONSTRAINTS	CONSTRAINT_TYPE
+TABLES	TABLE_CATALOG
+TABLES	TABLE_SCHEMA
+TABLES	TABLE_NAME
+TABLES	TABLE_TYPE
+TABLES	ENGINE
+TABLES	VERSION
+TABLES	ROW_FORMAT
+TABLES	TABLE_ROWS
+TABLES	AVG_ROW_LENGTH
+TABLES	DATA_LENGTH
+TABLES	MAX_DATA_LENGTH
+TABLES	INDEX_LENGTH
+TABLES	DATA_FREE
+TABLES	AUTO_INCREMENT
+TABLES	CREATE_TIME
+TABLES	UPDATE_TIME
+TABLES	CHECK_TIME
+TABLES	TABLE_COLLATION
+TABLES	CHECKSUM
+TABLES	CREATE_OPTIONS
+TABLES	TABLE_COMMENT
 SELECT *
 FROM information_schema.key_column_usage;
 CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_CATALOG	TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	ORDINAL_POSITION	POSITION_IN_UNIQUE_CONSTRAINT	REFERENCED_TABLE_SCHEMA	REFERENCED_TABLE_NAME	REFERENCED_COLUMN_NAME
 SELECT * 
 FROM information_schema.referential_constraints;
 CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	UNIQUE_CONSTRAINT_CATALOG	UNIQUE_CONSTRAINT_SCHEMA	UNIQUE_CONSTRAINT_NAME	MATCH_OPTION	UPDATE_RULE	DELETE_RULE	TABLE_NAME	REFERENCED_TABLE_NAME
+SELECT catalog_name, schema_name
+FROM information_schema.schemata;
+catalog_name	schema_name
+NULL	information_schema
+NULL	mysql
+NULL	test
 SELECT *
 FROM information_schema.table_constraints;
 CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_SCHEMA	TABLE_NAME	CONSTRAINT_TYPE
+SELECT table_schema, table_name
+FROM information_schema.tables;
+table_schema	table_name
+information_schema	GLOBAL_STATUS
+information_schema	GLOBAL_VARIABLES
+information_schema	SESSION_STATUS
+information_schema	SESSION_VARIABLES
+information_schema	INNODB_TRX
+information_schema	INNODB_LOCKS
+information_schema	INNODB_LOCK_WAITS
+information_schema	INNODB_CMP
+information_schema	INNODB_CMP_RESET
+information_schema	INNODB_CMPMEM
+information_schema	INNODB_CMPMEM_RESET
+information_schema	CHARACTER_SETS
+information_schema	COLLATIONS
+information_schema	COLLATION_CHARACTER_SET_APPLICABILITY
+information_schema	COLUMNS
+information_schema	KEY_COLUMN_USAGE
+information_schema	PLUGINS
+information_schema	PROCESSLIST
+information_schema	REFERENTIAL_CONSTRAINTS
+information_schema	SCHEMATA
+information_schema	STATISTICS
+information_schema	TABLE_CONSTRAINTS
+information_schema	TABLES

=== modified file 'tests/t/information_schema.test'
--- tests/t/information_schema.test	2009-06-29 15:34:22 +0000
+++ tests/t/information_schema.test	2009-07-01 02:05:39 +0000
@@ -427,6 +427,12 @@
 FROM information_schema.collation_character_set_applicability;
 
 #
+# perform a query on COLUMNS
+#
+SELECT table_name, column_name
+FROM information_schema.columns;
+
+#
 # perform a query on KEY_COLUMN_USAGE
 #
 SELECT *
@@ -439,11 +445,23 @@
 FROM information_schema.referential_constraints;
 
 #
+# query the SCHEMATA table
+#
+SELECT catalog_name, schema_name
+FROM information_schema.schemata;
+
+#
 # query TABLE_CONSTRAINTS table
 #
 SELECT *
 FROM information_schema.table_constraints;
 
+#
+# query TABLES
+#
+SELECT table_schema, table_name
+FROM information_schema.tables;
+
 # 
 # do a query on the PLUGINS table in I_S to ensure it works correctly
 # how do we test for this if the contents of this table can change

